-*- coding: utf-8 -*-

commit 269bd157ea7da576ff408a8dfeda8e4485f66a1e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-07 21:57:24 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:39:25 +0900

    Use `IO.popen` instead of `IO.foreach` with pipe

commit bc6f57ac15a99caaaadf1ca45a2c7a7cef85870d
  Author:     Lars Kanis <lars@greiz-reinsdorf.de>
  AuthorDate: 2025-08-03 16:18:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:38:09 +0900

    Revert to shell execution when invoking nm tool

    This reverts a change of commit b3598cf2a355497693bb66097edc156af3152e9b .
    On Windows on ARM64 with LLVM the "NM" tool is called with a parameter like so:
    ```
      RbConfig::CONFIG["NM"] # => "llvm-nm --no-llvm-bc"
    ```

    Therefore the command must be called with a shell string.

commit dd9163d468fc2997f2ef69f05d620f2649d23cbd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-31 16:45:09 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:37:54 +0900

    Win: Strip CRs from `cpp` and `nm` output

    The combination of mingw tools and cygin/msys2 ruby leaves CRs.

commit 5434aa3f7e8a243ae72fae4675991dc07cccc39f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 19:29:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:36:38 +0900

    Win32: Remove unreferenced COMDAT from object files

    Windows 11 SDK Version 10.0.26100.0 introduced a new internal inline
    function in ucrt/corecrt_math.h.  Even it appears in object files and
    will be included in the DEF file, it will be removed from the DLL and
    result in a linker error.

commit 3466ddbc0d05aa1dcf22164b2224409f6c24f289
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 10:54:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:36:32 +0900

    Workaround for VC 19.42.34433 again

    Prefix underscore is already removed here.

commit 3b060cfc6d3f26a9140465d6d040085b9e3e0dff
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-16 23:52:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:36:21 +0900

    Workaround for VC 19.42.34433

    Suddenly it began to add `_ucrt_int_to_float` by the recent version.

commit c5398d13977a22a470a17263ae38d773f5801606
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-16 22:46:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 14:36:08 +0900

    mkexports.rb: Revert removed flip-flop

    This reverts commit 63ae1e3cb5d302e5229143c00152328166d26780.

commit 9f045b904d7403741611146a0d907534ee0dce48
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-11-08 13:23:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 13:23:29 +0900

    unicode_normalize/normalize.rb: stop using `it` special block parameter in ruby_3_3.

commit e897657c0048b56d4925518fa94768aba8607d5d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-11-08 11:05:47 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-08 11:05:47 +0900

    merge revision(s) 377aa2a336cc700485c699ac49330f2a58b74906: [Backport #21668]

            [PATCH] Improve performance of UnicodeNormalize.canonical_ordering_one

            Use array_of_integer.sort! instead of buble-sort-like algorithm

commit 2da2d33cc49efd5508757aadc7e97db2968dfdfa
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-11-03 10:10:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-03 10:10:57 +0900

    merge revision(s) e500222de1a8d5e7a844209a7e912b03db8cdf76:

            [PATCH] fix last commit

            `th` is gone.

commit 609f957ebede1a062b1f34515382e4c306f77444
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-11-02 14:50:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:50:06 +0900

    merge revision(s) ffc69eec0a5746d48ef3cf649639c67631a6a609, 0531fa4d6fea100f69f0bac9e03973fe49ecd570: [Backport #21560]

            [PATCH] `struct rb_thread_sched_waiting`

            Introduce `struct rb_thread_sched_waiting` and `timer_th.waiting`
            can contain other than `rb_thread_t`.

            [PATCH] mn timer thread: force wakeups for timeouts

commit 780c2b9853219b56a18c2114ffb43801780b346a
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-29 18:59:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:12:31 +0900

    Remove old code for BMH search

    Remove the code for Boyer-Moore-Horspool search.
    Now we are using Sunday's quick search.

    https://github.com/k-takata/Onigmo/commit/3d9072419a1578b742a422412d004fd8a54209fd

commit cd116d2ac5369b9d0f5ae4421c2994556ebbf0ad
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-28 18:52:39 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:12:22 +0900

    Fix initialization of the table for quick search

    This fixes k-takata/Onigmo#120.

    The commit [k-takata/Onigmo@9c13de8d0684ebde97e3709d7693997c81ca374b](https://github.com/k-takata/Onigmo/commit/9c13de8d0684ebde97e3709d7693997c81ca374b) was insufficient.

    https://github.com/k-takata/Onigmo/commit/1de602ddff140d91419e3f86dd35c81d7bd2d8e7

commit 9f81d53068de6cd6ff96e7f102e6059c573b9005
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-25 18:58:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:12:14 +0900

    Avoid negative character

    Better fix for k-takata/Onigmo#107.

    https://github.com/k-takata/Onigmo/commit/85393e4a63223b538529e7095255ce1153c09cff

commit 70aeeeb515713b1632f7f7cc53e8dae326fc0fc9
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-25 18:56:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:12:00 +0900

    Fix lgtm.com warnings

    * Multiplication result may overflow 'int' before it is converted to
      'OnigDistance'.
    * Comparison is always true because code <= 122.
    * This statement makes ExprStmt unreachable.
    * Empty block without comment

    https://github.com/k-takata/Onigmo/commit/387ad616c3cb9370f99d2b11198c2135fa07030f

commit f0feca1a8495eba2706a7914f0c4f8128c281366
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-25 18:54:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:11:36 +0900

    [Bug #13671] Fix that "ss" in look-behind causes syntax error

    Fixes k-takata/Onigmo#92.

    This fix was ported from oniguruma:
    https://github.com/kkos/oniguruma/commit/257082dac8c6019198b56324012f0bd1830ff4ba

    https://github.com/k-takata/Onigmo/commit/b1a5445fbeba97b3e94a733c2ce11c033453af73

commit cbc1460efbc003e256cc239a4bb228e790308ecb
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-24 19:05:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:10:25 +0900

    Revert "[tune] implicit-anchor optimization"

    This reverts commit 282338f88a8bf0807a7a1d21b06f78abe9de8fac.
    It seems that the commit didn't improve the performance.
    Revert it to fix k-takata/Onigmo#100.

    https://github.com/k-takata/Onigmo/commit/cef834cb3a6e278fa252f52b704c65175a970ac0

commit 6809ba2fe57c2548836cf6512dae12599ced8e39
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2017-11-21 20:30:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:09:45 +0900

    Fix performance problem with /k/i and /s/i (Close k-takata/Onigmo#97)

    E.g.
    For the pattern `/----k/i`, optimization was totally turned off.
    Make it possible to use the characters before `k` (i.e. `----`) for
    optimization.

    https://github.com/k-takata/Onigmo/commit/9c13de8d0684ebde97e3709d7693997c81ca374b

commit e02c892ade90ee401daf26292fbb99d32af7f619
  Author:     Hiroya Fujinami <make.just.on@gmail.com>
  AuthorDate: 2025-07-31 13:08:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 14:05:12 +0900

    Fix indents in Onigmo files to use spaces instead of tabs (#14047) [no ci]

commit 30f661951bb19f69cf55388c76ecaf7b0be41079
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-11-02 13:28:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-11-02 13:28:40 +0900

    merge revision(s) 12350eb9e0d3317da57b5a37c0c2810946b48850: [Backport #21625]

            [PATCH] [Bug #21625] Allow io/wait methods with `IO#ungetc` in text mode

commit 93828c4711d2904c9d9ae84849877665ebd744e9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-25 13:59:03 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-25 13:59:03 +0900

    merge revision(s) 4368e6c42effc16904e35f753fc2002f0bba375a:

            [PATCH] [ruby/rubygems] Removed credential assertion from stdout

            https://github.com/ruby/rubygems/commit/3946be008c

commit bee70ff6988ef83bd43111a987a6a192a960da7b
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-25 13:58:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-25 13:58:15 +0900

    [ruby/rubygems] Bump up vendored uri to 0.13.3

commit 343ea050023cfc0374fdea6fdf625b2f57b716a4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-23 19:00:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-23 19:00:15 +0900

    bump teeny

commit ac27bec23f1a38a2368953d5ce7fe6115825e67e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-20 21:09:51 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-20 21:09:51 +0900

    merge revision(s) 957c832db137e67289e93dfd9fd9e915b1f2fc87:

            [PATCH] Fix memory leak in rb_const_remove when using namespace

            We need to free the rb_const_entry_t we remove from the RCLASS_WRITABLE_CONST_TBL
            otherwise it will leak memory.

commit 4365a09466462836c0e5f88d15736846734b8216
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-18 14:43:19 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-18 14:43:19 +0900

    Don't check existence of openssl-1.1 dll files on GHA mingw workflow.

commit 599257ea3310b2897164317ed4e86e7b3a5cd6a7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-18 12:26:34 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-18 12:26:34 +0900

    Stop renaming openssl dll files on GHA mingw workflow.

commit 4a09da622a8aabb3d2e68cf38addf544a5c06c13
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-18 12:20:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-18 12:20:09 +0900

    partially merge revision 949573028b127931cb034a2928ef80a59c45ea43:

            [PATCH] Win32: OpenSSL 1.1 DLLs are no longer used

            We are already using OpenSSL 3.3 and have no possibility to use system
            provided DLLs.

commit e526fbe770909974f610b7a2a00bd8d5dd045f1f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-18 11:20:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-18 11:20:54 +0900

    merge revision(s) e94a2f691d67ad98be9036e76c765fcfa7d22552: [Backport #21638]

            [PATCH] [Bug #21638] Mark ractor-local `$VERBOSE` and `$DEBUG`

            https://github.com/sampersand/blog/blob/master/the%20-s%20flag.md#the-segfault

commit a4ca3de38e8910d7fc8968036157c08cb2604af5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-11 18:28:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-11 18:28:36 +0900

    merge revision(s) 07b59eee6aa120537d7d72422327cc7b855e9400:

            [PATCH] Fix memory leak when load_from_binary raises

            ibf_load_code will leak memory allocated for the code if an exception is
            raised. The following script reproduces the leak:

                bin = RubyVM::InstructionSequence.of(1.method(:abs)).to_binary

                10.times do
                  100_000.times do
                    RubyVM::InstructionSequence.load_from_binary(bin)
                  rescue ArgumentError
                  end
                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                18004
                23380
                28756
                34260
                39892
                45396
                50772
                55892
                61012
                66132

            After:

                12536
                12920
                13304
                13688
                14072
                14456
                14840
                15352
                15608
                15864

commit 7e31d3c0229095b6b256ba04288869a6373938b6
  Author:     刘皓 <whiteaxe@tuta.io>
  AuthorDate: 2025-10-09 09:45:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-11 18:27:37 +0900

    Backport WASI setjmp handler memory leak fixes to Ruby 3.3

commit 27a1df7506ba566d08a536e93910fff574cd6d56
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-11 17:01:06 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-11 17:01:06 +0900

    merge revision(s) 7ae67e8f6ad6e7fd0677b28a7a10961f79d55495: [Backport #21568]

            [PATCH] load.c: Fix dest and src of MEMMOVE

            When multiple files with the same name are required, the features_index
            hash stores the indexes in `$LOADED_FEATURES` array into a darray.
            The dest and src arguments for `MEMMOVE` were wrongly reversed when
            inserting a new index in the darray.

            [Bug #21568]

commit ce7aa23f97273fa181be26aec33d3c6998e203c5
  Author:     Bo Anderson <mail@boanderson.me>
  AuthorDate: 2025-10-09 12:24:27 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-11 16:53:43 +0900

    Update openssl gem to 3.2.2

commit f427353653e5488d4f8da1066d07d392a42a00f2
  Author:     Bo Anderson <mail@boanderson.me>
  AuthorDate: 2025-10-09 12:45:43 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-09 23:11:57 +0900

    Update rexml to 3.4.4

commit 7a197de7aef31e47fbe9ceb2d985ba3fc75919fa
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:37:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-09 23:08:48 +0900

    Fix tests to verify basic authentication

commit 3fe7f490ff654db9fac004ff030204d9d69fbe98
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:28:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-09 23:08:48 +0900

    Merge URI-0.13.3

commit 4fb1eec1e34a73da6f38ae9d344d4c9cb73eb955
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-09 06:23:12 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 06:23:12 +0900

    post_push.yml: Backport commit-mail to ruby_3_3 (#14782)

commit 5a8d7642168f4ea0d9331fded3033c225bbc36c5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-08 22:55:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-08 22:56:02 +0900

    merge revision(s) 43dbb9a93f4de3f1170d7d18641c30e81cc08365, 2bb6fe3854e2a4854bb89bfce4eaaea9d848fd1b, 7c9dd0ecff61153b96473c6c51d5582e809da489: [Backport #21629]

            [PATCH] [Bug #21629] Enable `nonstring` attribute on clang 21

            [PATCH] [Bug #21629] Initialize `struct RString`

            [PATCH] [Bug #21629] Initialize `struct RArray`

commit a8f488482a60554515ab5f5e360e79f80d3fa344
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 17:10:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 17:10:05 +0900

    Backport fetch_changesets to ruby_3_3 (#14773)

commit dcb66fcae7bc4b4b337ca1083dd1e125923ac74f
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 13:42:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 13:42:13 +0900

    Backport post_push.yml workflow to ruby_3_3 (#14770)

commit 183e2b0a2389579a3a5b205113db72345b52dd85
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-09-18 12:24:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-06 07:50:39 +0900

    Use `ec->interrupt_mask` to prevent interrupts. [Backport #21610]

    Disallow pending interrupts to be checked during `FiberScheduler#unblock`.

    Ractors can send signals at any time, so the previous debug assertion can fail if a Ractor sends a signal.

    Co-authored-by: Luke Gruber <luke.gruber@shopify.com>

commit 05f93fe6dc6f99fd2f728dd3c85dca944f1f4ba1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-05 19:10:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 19:10:48 +0900

    merge revision(s) 62430c19c9f1ab49429cebe65f30588472648c95: [Backport #21342]

            Message not found for revision: 62430c19c9f1ab49429cebe65f30588472648c95

commit 62ecd47656e0c8c7f308fc798ab6106d738c211e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-05 19:00:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 19:00:40 +0900

    merge revision(s) 354d47ae5bc4edcc94db4a5391ed71a8b9844e57: [Backport #21569]

            Message not found for revision: 354d47ae5bc4edcc94db4a5391ed71a8b9844e57

commit 7a67358006207f525a78775e1417ad4fb7b0484d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-05 09:39:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 09:39:04 +0900

    merge revision(s) ef2b26cc3eaed06c5c9d4ef2c6d8669ff357afa4: [Backport #21611]

            Message not found for revision: ef2b26cc3eaed06c5c9d4ef2c6d8669ff357afa4

commit b202a1fe034e9e4e77fb778ad032c01d014d677f
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 12:10:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 09:37:26 +0900

    Use write barriers when loading catch table

    Found by wbcheck

commit 7a4c7eac9b262fd7036d86b58d0dc2f188bd5838
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 12:05:18 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 09:37:26 +0900

    Add missing write barriers to ibf_load

    Found by wbcheck

commit 1811211d6dea45783c855a9a7b692124e7479292
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-10-05 09:16:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-10-05 09:16:20 +0900

    merge revision(s) 7a05dbc47831a655a1ef8a1635f88292acd325da: [Backport #21561]

            Message not found for revision: 7a05dbc47831a655a1ef8a1635f88292acd325da

commit 01b0beb818e74c290fdf8fcc824946fd8c93b373
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-09-14 13:47:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-09-14 13:47:35 +0900

    merge revision(s) 928fea3bfa86053c0bc6f7a5bf7559b115a676b5: [Backport #21567]

            Fix crash when $LOADED_FEATURES is modified during require

            [Bug #21567]

            When we require an object that is not a string, it will attempt to convert
            it to a string by calling to_str on it. If we modify the $LOADED_FEATURES
            array while it calls to_str, Ruby can crash because it can end up inserting
            the string in the wrong index in the array.

            For example, the following script crashes:

                require "tempfile"

                class MyString
                  def initialize(path)
                    @path = path
                  end

                  def to_str
                    $LOADED_FEATURES.clear
                    @path
                  end

                  def to_path = @path
                end

                def create_ruby_file = Tempfile.create(["test", ".rb"]).path

                require MyString.new(create_ruby_file)
                $LOADED_FEATURES.unshift(create_ruby_file)
                $LOADED_FEATURES << MyString.new(create_ruby_file)
                require create_ruby_file

            Crash log:

                test.rb:21: [BUG] Segmentation fault at 0x0000000000000004
                ruby 3.5.0dev (2025-09-09T09:29:35Z master ce94add7fb) +PRISM [arm64-darwin24]

                -- Crash Report log information --------------------------------------------
                  See Crash Report log file in one of the following locations:
                    * ~/Library/Logs/DiagnosticReports
                    * /Library/Logs/DiagnosticReports
                  for more details.
                Don't forget to include the above Crash Report log file in bug reports.

                -- Control frame information -----------------------------------------------
                c:0003 p:---- s:0011 e:000010 CFUNC  :require
                c:0002 p:0076 s:0006 e:000005 EVAL   test.rb:21 [FINISH]
                c:0001 p:0000 s:0003 E:0001b0 DUMMY  [FINISH]

                -- Ruby level backtrace information ----------------------------------------
                test.rb:21:in '<main>'
                test.rb:21:in 'require'

                -- Threading information ---------------------------------------------------
                Total ractor count: 1
                Ruby thread count for this ractor: 1

                -- Machine register context ------------------------------------------------
                  x0: 0x0000000000000004  x1: 0x000000000000c800  x2: 0x0000000000000000
                  x3: 0x0000000000000000  x4: 0x0000000000000205  x5: 0x0000000000000000
                  x6: 0x0000000000000000  x7: 0x0000000000000001 x18: 0x0000000000000000
                x19: 0x0000000209dfc0b0 x20: 0x0000000209dfc018 x21: 0x000000016ee8ab58
                x22: 0x0fffffff0009d71d x23: 0x0000000209dfc018 x24: 0x0000000209dfc150
                x25: 0x000000016ee8acc0 x26: 0x0000000000000000 x27: 0x0000000000000000
                x28: 0x0000000000000000  lr: 0x0000000101244140  fp: 0x000000016ee887f0
                  sp: 0x000000016ee887d0

                -- C level backtrace information -------------------------------------------
                miniruby(rb_print_backtrace+0x24) [0x101317b08] vm_dump.c:843
                miniruby(rb_print_backtrace) (null):0
                miniruby(rb_vm_bugreport+0x26c) [0x101317d94] vm_dump.c:1175
                miniruby(rb_bug_for_fatal_signal+0xa4) [0x10105ddac] error.c:1130
                miniruby(sig_do_nothing+0x0) [0x1012278c0] signal.c:948
                miniruby(sigsegv) (null):0
                /usr/lib/system/libsystem_platform.dylib(_sigtramp+0x38) [0x19c1216a4]
                miniruby(rb_str_new_frozen+0x1c) [0x101244140] string.c:1495
                miniruby(rb_check_realpath_internal+0x68) [0x101077804] file.c:4679
                miniruby(rb_check_realpath+0x2c) [0x101077aa4] file.c:4765
                miniruby(get_loaded_features_index+0x37c) [0x1010f9c94] load.c:467
                miniruby(rb_feature_p+0xd0) [0x1010f8174] load.c:582
                miniruby(search_required+0xac) [0x1010f6ad4] load.c:1193
                miniruby(require_internal+0x274) [0x1010f7518] load.c:1424
                miniruby(rb_require_string_internal+0x94) [0x1010f6830] load.c:1571
                miniruby(rb_require_string+0x58) [0x1010f66e8] load.c:1557
                miniruby(rb_f_require+0x1c) [0x1010f6684] load.c:1150
                miniruby(ractor_safe_call_cfunc_1+0x38) [0x101306c28] vm_insnhelper.c:3696
                miniruby(vm_call_cfunc_with_frame_+0x250) [0x1012f857c] vm_insnhelper.c:3873
                miniruby(vm_call_cfunc_with_frame+0x6c) [0x1012f8834] vm_insnhelper.c:3919
                miniruby(vm_sendish+0x1a8) [0x1012c990c] vm_insnhelper.c:6087
                miniruby(vm_exec_core+0x4050) [0x1012cfb48] insns.def:900
                miniruby(vm_exec_loop+0x80) [0x1012e5448] vm.c:2666
                miniruby(rb_vm_exec+0x134) [0x1012c9b40] vm.c:2645
                miniruby(rb_iseq_eval_main+0x34) [0x1012e5628] vm.c:2919
                miniruby(rb_ec_exec_node+0xe4) [0x10106d094] eval.c:282
                miniruby(ruby_run_node+0x94) [0x10106cf64] eval.c:320
                miniruby(rb_main+0x40) [0x100f7499c] main.c:42
                miniruby(main+0x60) [0x100f74928] main.c:62

commit 210643c51d706a486ad460111eac51d4d34639cf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-09-14 13:24:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-09-14 13:24:54 +0900

    merge revision(s) 7c28fb2fb2544e5fed75ef216c4dd08084b38671: [Backport #21546]

            [Bug #21546] Make the generated pc file relocatable

commit e39a0a19c03fbb37d1c9d1e050bb551dccfc11c6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-09-14 12:47:12 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-09-14 12:47:12 +0900

    merge revision(s) ce849d565bf6aae8e0179fffb04eb1f665f17347, acb29f7fa1497463ed3bdd65549ef20b61beda64: [Backport #21402]

            ruby2_keywords warnings: Quote non-UTF8 method names fully

            It used to quote only part of the method name because NUL byte in
            the method terminates the C string:

            ```
            (irb)> "abcdef".encode("UTF-16LE").bytes
            => [97, 0, 98, 0, 99, 0, 100, 0, 101, 0, 102, 0]
            ```

            ```
            expected: /abcdef/
            actual: warning: Skipping set of ruby2_keywords flag for a (method not defined in Ruby)\n".
            ```

            Do not respect ruby2_keywords on method/proc with post arguments

            Previously, ruby2_keywords could be used on a method or proc with
            post arguments, but I don't think the behavior is desired:

            ```ruby
            def a(*c, **kw) [c, kw] end
            def b(*a, b) a(*a, b) end
            ruby2_keywords(:b)

            b({foo: 1}, bar: 1)
            ```

            This changes ruby2_keywords to emit a warning and not set the
            flag on a method/proc with post arguments.

            While here, fix the ruby2_keywords specs for warnings, since they
            weren't testing what they should be testing.  They all warned
            because the method didn't accept a rest argument, not because it
            accepted a keyword or keyword rest argument.

commit 1b6a5479ded7a6f714d0b4bee94869a27a1607f8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-02 01:31:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-08-29 10:20:36 +0900

    Backport GH-13617 for s390x (#13757)

commit fda30bd8225660602e87f2d28be3619ec142e759
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-29 00:44:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-08-02 21:00:36 +0900

    Correct castings to use OnigDistance

commit d142f6bce02038e9e24abcbada28247559765d16
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 18:45:57 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-08-02 21:00:36 +0900

    Add castings to prevent warnings

commit 92785d51e1009fabc4c1f1c4f31c7c1ec2fc115c
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 17:50:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-08-02 21:00:36 +0900

    Port a Oniguruma patch: Integer overflow in onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/778a43dd56925ed58bbe26e3a7bb8202d72c3f3f

    It differs from the Oniguruma patch in that it dosen't use `onigenc_get_prev_char_head()`
    because this function's signature has been changed by Oniguruma and the change is not ported
    in Onigmo for now. This patch respects the current Onigmo implementation.

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit 726a19f4d058054ea16878a4165852ed9768de08
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:18:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-08-02 21:00:36 +0900

    Port a Oniguruma patch: Integer overflow in backward_search_range() and onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/bfc36d3d8139b8be4d3df630d625c58687b0c7d4

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit f2d4bea53d3ba98e04f0a22c4bc2e8cd299281ea
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:05:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-08-02 21:00:36 +0900

    Port a Oniguruma patch: Integer overflow in forward_search_range()

    https://github.com/kkos/oniguruma/commit/db64ef3189f54917a5008a02bdb000adc514a90a

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit f5c772fc7cbe9f5b58d962939fcb1c7e3fb1cfa6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-24 19:04:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-24 19:04:28 +0900

    bump teeny

commit 361d14319b8944e6abf207cfda4904360321c861
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-24 17:15:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-24 17:15:54 +0900

    merge revision(s) 5e5cec1b86837653b2106af377561045f4bbecef:

            Fix bigand_int edgecase returning false (#13987)

commit 83335453c245ab2e7c92a6ae28de08a649e844d9
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-24 16:44:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-24 16:44:37 +0900

    Revert bump versions of default gems for extconf.rb changes.

    This reverts commit 91263c7e523dd0345c35ac4b616676132aad09d1.

commit 9a269b15f56bd082cd227b91ae1549058890f73b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/json] Run `have_func` with the header providing the declarations

    https://github.com/ruby/json/commit/95fb084027

commit dd84f059cb60ebd27763b6114a096843a682560f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/strscan] Run `have_func` with the header providing the declarations

    https://github.com/ruby/strscan/commit/18c0a59b65

commit 2af51ec4803a65481eadd862abc87ac516e08da3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-06-12 10:32:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/strscan] Update extconf.rb
    (https://github.com/ruby/strscan/pull/158)

    - `have_func` includes "ruby.h" by default.
    - include "ruby/re.h" where `rb_reg_onig_match` is declared.

    https://github.com/ruby/strscan/commit/1ac96f47e9

commit bf08633e0f3d1b52c2ebb35d89591b6775ccb320
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/openssl] Run `have_func` with the header providing the declarations

    https://github.com/ruby/openssl/commit/b6f56c4540

commit 280cf2ad813c65cdc9b78d9b20d68904c992e380
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 17:04:50 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    Bump io-nonblock to 0.3.0.1

commit 2493ec4f5e0114d5442f6b8e0732f9e380f0b2fb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/io-nonblock] Run `have_func` with the header providing the declarations

    https://github.com/ruby/io-nonblock/commit/70909f5362

commit e997c7f26e2cc21c40a2bd27bfe807e69d091183
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 17:01:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    Bump io-wait to 0.3.1.1

commit 8fab4f20a83eacc28d66c7ab6fe615386a7e987f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/io-wait] Run `have_func` with the header providing the declarations

    https://github.com/ruby/io-wait/commit/48309d7877

commit 1d275bfd390912dc68c6903c7ebf5b0214cd6fff
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 16:57:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    Bump io-console to 0.7.1.1

commit fb42816c53295e7099f98c6039e5fd1d1bbebc7b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/io-console] Run `have_func` with the header providing the declarations

    https://github.com/ruby/io-console/commit/dd013030dd

commit 91263c7e523dd0345c35ac4b616676132aad09d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 16:54:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    bump etc-1.4.3.1

commit fd6d582427f75eee2373bdcbaa598365c6eb76a9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    [ruby/etc] Run `have_func` with the header providing the declarations

    https://github.com/ruby/etc/commit/6668bfd42a

commit 868bcf3807c25ddeb30838f6eee6670bad7bb313
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 16:22:30 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    Update dependency for goruby

commit f0ec1ad8275c131644bc684e52748fff9b96bbe8
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 16:13:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    Add compilation with GCC 14,15 on GitHub workflow

commit 407f6c9d0528fa6aa3f382eb1dce3a58baf5d571
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 16:10:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 18:32:03 +0900

    merge revision(s) b42afa1dbcbb91e89852b3b3bc72484d7f0a5528, 67b91e780798b80038dbfb39a06831918a75259f, f1f0cc14cc7d3f9be35b203e5583f9224b1e2387, 543e3a1896ae2fe3b5b954f6497d261ab5663a15, ed2806117a0b76e4439ce1a061fae21d9e116d69, 46e4c8673747de96838d2c5dec37446d23d99d88: [Backport #21497]

            Suppress gcc 15 unterminated-string-initialization warnings

            Drop an ignored attribute
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            GCC 13.3.0 (Ubuntu 24.04) emits the following warning:

            ../symbol.c: In function ‘rb_id_attrset’:
            ../symbol.c:175:9: warning: ‘nonstring’ attribute ignored on objects of type ‘const char[][8]’ [-Wattributes]
              175 |         RBIMPL_ATTR_NONSTRING() static const char id_types[][8] = {
                  |         ^~~~~~~~~~~~~~~~~~~~~

            Separate `__has_attribute` from `defined(__has_attribute)`

            Fix Visual C warnings:
            ```
            regenc.h(121): warning C4067: unexpected tokens following preprocessor directive - expected a newline
            ```

            Cast up `int` instruction code to `VALUE`

            Fix Visual C warnings:
            ```
            iseq.c(3793): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
            iseq.c(3794): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
            ```

            Do not let files depend on a phony target

            Detect `clock_gettime` and `clock_getres` for winpthreads

commit 1e37f34eaad715119d49c13e0bf6e6c54c5cbca6
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 15:49:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 15:49:08 +0900

    merge revision(s) d77e02bd85ab7f841df8d473bac214b9a92a3506: [Backport #21497]

            [Bug #21497] [ruby/socket]: add full prototype
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            otherwise, gcc 15 will complain:

            > init.c:573:19: error: too many arguments to function ‘Rconnect’; expected 0, have 3
            >   573 |     return (VALUE)Rconnect(arg->fd, arg->sockaddr, arg->len);
            >       |                   ^~~~~~~~ ~~~~~~~
            > In file included from init.c:11:
            > rubysocket.h:294:5: note: declared here
            >   294 | int Rconnect();
            >       |     ^~~~~~~~

            > sockssocket.c:33:9: error: too many arguments to function ‘SOCKSinit’; expected 0, have 1
            >    33 |         SOCKSinit("ruby");
            >       |         ^~~~~~~~~ ~~~~~~
            > In file included from sockssocket.c:11:
            > rubysocket.h:293:6: note: declared here
            >   293 | void SOCKSinit();
            >       |      ^~~~~~~~~

            Signed-off-by: Z. Liu <zhixu.liu@gmail.com>

commit 9b9f244b9837d2f3f1128591823eabe55f1a3204
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 15:43:31 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 15:43:31 +0900

    merge revision(s) 1181a682a6c314c92686e3701defa1eb44068c4e, 0cec4a14fb832aed4b498a21ec0c19765642d408, d84a811f31a65821642b165d712f380c0cc060e0: [Backport #21448]

            [Bug #21448] Use `getentropy(2)` only on macOS

            If this is not a system call, then it is using getrandom (which would
            have been tried already), and cannot be used as a replacement for the
            random devices.

            Restore getrandom(2) path for Linux with glibc 2.36 or later

            This is a follow-up to commit b120f5e38d9c (avoid fork-unsafe arc4random
            implementations, 2018-09-04).

            Avoid defining a no-op fill_random_bytes_syscall() if arc4random_buf(3)
            exists, but we are unsure if it is fork-safe. Check for other options
            instead. IOW, see if getrandom(2) is available.

            glibc 2.36, released in 2022, started to provide arc4random_buf(3) on
            Linux. This causes fill_random_bytes_syscall() to use neither of them
            and makes Random.urandom solely rely on getentropy(3) via
            fill_random_bytes_urandom().

            While the glibc implementation is safe, I did not add it to the list
            because using getrandom(2) directly is preferable on Linux.

            [Bug #21448] Reorder trials in `fill_random_bytes`

            First try dedicated system calls, such as `getrandom` or `getentropy`,
            next possible libraries, then fallback to `/dev/urandom`.

commit f4de78f2b4bd5be3735de9ccbaa89a0f495b6f10
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-20 10:35:44 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-20 10:35:44 +0900

    merge a revision partially 097d742a1ed53afb91e83aef01365d68b763357b: [Backport #20009]

commit 581be2b79cca0cb977fc0d6745cec7dbbe29b134
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-07-19 11:16:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-19 11:16:49 +0900

    merge revision(s) 097d742a1ed53afb91e83aef01365d68b763357b: [Backport #20009]

            [Bug #20009] Support marshaling non-ASCII name class/module

commit 3471ee0749be4bf9bfdd382ac0b6aedaf47a53b1
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-14 10:52:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-19 10:23:17 +0900

    Fix generic_ivar_set_shape_ivptr for table rebuild

    [Bug #21438]

    Previously GC could trigger a table rebuild of the generic ivar
    st_table in the middle of calling the st_update callback. This could
    cause entries to be reallocated or rearranged and the update to be for
    the wrong entry.

    This commit adds an assertion to make that case easier to detect, and
    replaces the st_update with a separate st_lookup and st_insert.

    Also free after insert in generic_ivar_set_shape_ivptr

    Previously we were performing a realloc and then inserting the new value
    into the table. If the table was flagged as requiring a rebuild, this
    could trigger GC work and marking within that GC could access the ivptr
    freed by realloc.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>
    Co-authored-by: Jean Boussier <byroot@ruby-lang.org>

commit 111a49e77e4b05a21bb37942ea2cfc254daa8d92
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-08 16:39:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-07-19 10:19:07 +0900

    Bump up resolv-0.3.1 for Ruby 3.3

commit 7fb19cf8035cb3e4209c93c70a224382e4c8ee6f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-01 16:57:26 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-02 11:05:40 +0900

    Partly picked from https://github.com/ruby/ruby/pull/10073

commit a52a2e852a38fbf3c2b5184a4fa64951b47ae03a
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-06-18 05:56:26 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-29 13:08:00 +0900

    thread_cleanup: set CFP to NULL before clearing ec's stack

    We clear the CFP first so that if a sampling profiler interrupts the current thread during `rb_ec_set_vm_stack`,
    `thread_profile_frames` returns early instead of trying to walk the stack that's no longer set on the ec.

    The early return in `thread_profile_frames` was introduced at eab7f4623fb.

    Fixes [Bug #21441]

commit 1fb5ab411f618f651926ecae9427605e03e19884
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-29 12:31:38 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-29 12:31:38 +0900

    merge revision(s) c1877d431e76f4a782d51602fa8487e98d302956: [Backport #21437]

            [ruby/date] [Bug #21437] Date#hash for large years

            Addresses https://bugs.ruby-lang.org/issues/21437

            Signed-off-by: Dmitry Dygalo <dmitry.dygalo@workato.com>

            https://github.com/ruby/date/commit/31f07bc576

commit a976792832887ee2ae1380ab0e2244067126f017
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-29 12:27:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-29 12:27:54 +0900

    merge revision(s) 2e7e78cd590d20aa9d41422e96302f3edd73f623: [Backport #21440]

            [Bug #21440] Stop caching member list in frozen Data/Struct class

commit de512b7a3d392f8cbf95ac40504b2229e5fdf229
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 11:26:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 15:22:36 +0900

    We don't need to specify winsdk version

    a205407e165e4570b8b6d6e4b7a019b51962ecba fixed that workaround

commit 8908cb07829628115f7455508c2d5885ac99c939
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-15 12:51:29 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-15 12:51:29 +0900

    merge revision(s) fa85d23ff4a02985ebfe0716b0ff768f5b4fe13d: [Backport #21380]

            [Bug #21380] Prohibit modification in String#split block

            Reported at https://hackerone.com/reports/3163876

commit a205407e165e4570b8b6d6e4b7a019b51962ecba
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-14 17:43:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-14 17:43:36 +0900

    merge revision(s) 72bda0f981c7136f50254c433bbfb97a953f634b: [Backport #21255]

            [Bug #21255] Win32: Do not export `__declspec(selectany)` symbols

            ```
            x64-vcruntime140-ruby350.def : error LNK2001: unresolved external symbol Avx2WmemEnabledWeakValue
            ```

commit dc88822c3eabbd3f5ac080b1ff1059b1f0066bd2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-14 17:41:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-14 17:41:04 +0900

    merge revision(s) e1adb6cb15129a54df0c55a337e98b92b2a55e3f: [Backport #21283]

            Win: Suppress false warnings from Visual C 17.14.1

            https://developercommunity.visualstudio.com/t/warning-C5287:-operands-are-different-e/10877942?

            It is not able to silence "operands are different enum types"
            warnings, even using an explicit cast, as the message says.

commit 5de0c228a34dc919b663b547f933fb276333fdce
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-14 11:41:49 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-14 11:41:49 +0900

    merge revision(s) 2297afda7ff3926c51fea700dfbf0f0eb4fea1e5: [Backport #21340]

            Include stdbool.h without checking with autoconf

            As reported in <https://bugs.ruby-lang.org/issues/21340>, older autoconf
            have an AC_HEADER_STDBOOL that's incompatible with C23. Autoconf 2.72
            fixed the macro, but also mentions that it's obsolescent since all
            current compilers have this header.

            Since we require C99 [1] and VS 2015 [2], we might actually be able take
            that suggestion and include stdbool.h without a check. I want to try
            this on rubyci.org and will revert if this cause any issues. Not
            touching AC_HEADER_STDBOOL in configure.ac for now.

            [1]: https://bugs.ruby-lang.org/issues/15347
            [2]: https://bugs.ruby-lang.org/issues/19982

commit d5c8fd2043f4425c3fe2a87558dfbd80ebff9911
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-06-14 11:39:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-06-14 11:39:08 +0900

    merge revision(s) f6cbf499bc98b851034fffb49fcbb59d495f6f7b: [Backport #21354]

            Fix Symbol#to_proc (rb_sym_to_proc) to be ractor safe

            In non-main ractors, don't use `sym_proc_cache`. It is not thread-safe
            to add to this array without a lock and also it leaks procs from one
            ractor to another. Instead, we create a new proc each time. If this
            results in poor performance we can come up with a solution later.

            Fixes [Bug #21354]

commit fb8248b3e8d099662b37b118bc7152aed82dfcc8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-21 17:33:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-10 11:06:34 +0900

    Disabled TRAP cache of CodeQL

commit 6ca52090ed7e3d85d15ddd2093745512e055803f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-03 08:43:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-03 10:12:43 +0900

    Remove hardcoded version of rake from Bundler tests

    The original commit is https://github.com/rubygems/rubygems/commit/85f73e42a563ac6848ba22aeae344a5bdc5a9ed7

commit c1c068e43c80aeb2e711b64261323594eca66217
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-24 18:12:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-24 18:12:02 +0900

    Follow up for 380938998415c22ba3ca9bc01f4035d5a73f274d. The type of jump_to_next_insn() is Option<()> on ruby_3_3.

commit 7230a070e3dffc765fc6617436a2293c459c6c8d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-24 17:27:33 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-24 17:27:33 +0900

    Follow up for 380938998415c22ba3ca9bc01f4035d5a73f274d. jump_to_next_insn() require 3rd argument on ruby_3_3.

commit 380938998415c22ba3ca9bc01f4035d5a73f274d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-24 16:38:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-24 16:38:32 +0900

    merge revision(s) cbf9c088f8005a49b6aa3f475c70041357774c61: [Backport #21310]

            YJIT: End the block after OPTIMIZE_METHOD_TYPE_CALL (#13245)

commit 24c994b91a67f0023e8fe22a5428581110564332
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-24 10:25:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-24 10:25:59 +0900

    merge revision(s) 056497319658cbefe22351c6ec5c9fa6e4df72bd: [Backport #21357]

            [Bug #21357] Fix crash in Hash#merge with block

            Prior to https://github.com/ruby/ruby/commit/49b306ecb9e2e9e06e0b1590bacc5f4b38169c3c
            the `optional_arg` passed from `rb_hash_update_block_i` to `tbl_update`
            was a hash value (i.e. a VALUE). After that commit it changed to an
            `update_call_args`.

            If the block sets or changes the value, `tbl_update_modify` will set the
            `arg.value` back to an actual value and we won't crash. But in the case
            where the block returns the original value we end up calling
            `RB_OBJ_WRITTEN` with the `update_call_args` which is not expected and
            may crash.

            `arg.value` appears to only be used to pass to `RB_OBJ_WRITTEN` (others
            who need the `update_call_args` get it from `arg.arg`), so I don't think
            it needs to be set to anything upfront. And `tbl_update_modify` will set
            the `arg.value` in the cases we need the write barrier.

commit 8f895758d9512466e9ec24ce8e588f059c16136c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-24 10:24:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-24 10:24:22 +0900

    merge revision(s) 49b306ecb9e2e9e06e0b1590bacc5f4b38169c3c: [Backport #21333]

            [Bug #21333] Prohibit hash modification inside Hash#update block

commit d15fdb5c7ff204ebed7e24da5a921bf200426202
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-22 15:29:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-22 21:10:17 +0900

    Win32: Initialize the systemtime function before converting FILETIME

commit ff1d6157460f69399e98d547cbfaadc22b6870a1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-22 15:06:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-22 15:54:24 +0900

    Don't need to store download cache of vcpkg

    vcpkg can detect their cache from `vcpkg/installed`.

commit f57dd4470b9ba1e2e0007e814f94e8bb4fd2ab6f
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-18 16:25:01 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-18 16:25:01 +0900

    merge revision(s) 80a1a1bb8ae8435b916ae4f66a483e91ad31356a: [Backport #21257]

            YJIT: Fix potential infinite loop when OOM (GH-13186)

            Avoid generating an infinite loop in the case where:
            1. Block `first` is adjacent to block `second`, and the branch from `first` to
               `second` is a fallthrough, and
            2. Block `second` immediately exits to the interpreter, and
            3. Block `second` is invalidated and YJIT is OOM

            While pondering how to fix this, I think I've stumbled on another related edge case:
            1. Block `incoming_one` and `incoming_two` both branch to block `second`. Block
               `incoming_one` has a fallthrough
            2. Block `second` immediately exits to the interpreter (so it starts with its exit)
            3. When Block `second` is invalidated, the incoming fallthrough branch from
               `incoming_one` might be rewritten first, which overwrites the start of block
               `second` with a jump to a new branch stub.
            4. YJIT runs of out memory
            5. The incoming branch from `incoming_two` is then rewritten, but because we're
               OOM we can't generate a new stub, so we use `second`'s exit as the branch
               target. However `second`'s exit was already overwritten with a jump to the
               branch stub for `incoming_one`, so `incoming_two` will end up jumping to
               `incoming_one`'s branch stub.

            Fixes [Bug #21257]

commit 1f226f1efeeae3a5091c60e2f51e027d0598f394
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-18 13:32:52 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-18 13:32:52 +0900

    merge revision(s) b959263b58e26ef630c085f9f7ddc04373a998c7: [Backport #21344]

            Fix Exception#detailed_message for GC compaction

            Before this commit, the test fails with RGENGC_CHECK_MODE enabled:

                TestException#test_detailed_message_under_gc_compact_stress [test/ruby/test_exception.rb:1466]:
                <"\e[1mfoo (\e[1;4mRuntimeError\e[m\e[1m)\e[m\n" +
                "\e[1mbar\e[m\n" +
                "\e[1mbaz\e[m"> expected but was
                <"\e[1mfoo (\e[1;4mRuntimeError\e[m\e[1m)\e[m\n" +
                "\e[1m\x00\x00\x00\x00\x00\x00\x00\e[m">.

commit 74f46982ebfbec4d21b6fc8aff47f2e290307d36
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-05-01 01:59:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-18 13:30:24 +0900

    Bump net-imap to v0.4.21 for Ruby 3.3 (CVE-2025-43857)

    v0.4.20 addresses CVE-2025-43857 (GHSA-j3g3-5qv5-52mj).

    v0.4.21 fixes bugs in `Net::IMAP::SequenceSet`.

commit 551c444f810df5d22f5045f2fb69477a9fe40845
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-18 12:00:23 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-18 12:00:23 +0900

    merge revision(s) b48b841378f80e16378ceb83f3b78e52df9ae023, 2fe8b9cd3d308d754f3d33a948dfb1dd782a10dc: [Backport #21327]

            digest.so needs ruby/digest.h which is installed by build-ext

            Copy to path with the base name

commit 8a1d738b80408db5713c6b83adb0e5ce354360e5
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-18 10:24:11 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-18 10:24:11 +0900

    merge revision(s) 3113bc8d445c4c24ed3827adfc50bb88c99b6364:

            stat command is not provided on Windows

commit cb49400d680894d69534b0b4cd10b085de325e2a
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-17 15:57:05 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-17 15:57:05 +0900

    merge revision(s) 7793b59c8d2a13c124fe276e11723db23facce04: [Backport #21331]

            [Bug #21331] Prohibit hash modification during stlike loop

commit b25bfd33e974e7f46199d5908969e6d52cec31e7
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-17 15:56:46 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-17 15:56:46 +0900

    merge revision(s) 7f5b4fb26ea8c0a736a37101327905eebebee8bf:

            Remove unused retval assignments

commit a3adc05a4e1f5c5d1cd95eee92da9693b23360bf
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-17 15:41:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-17 15:41:00 +0900

    merge revision(s) 3e47e7a499acd256be549935fcb559d3c82e556c, 46e4c8673747de96838d2c5dec37446d23d99d88:

            Fix redefinition of `clock_gettime` and `clock_getres`

            winpthreads-git 12.0.0.r720 provides `clock_gettime` and
            `clock_getres` as inline functions.

            Detect `clock_gettime` and `clock_getres` for winpthreads

commit b1b6752fbeb2d23dbea639bd4b331c9e8b56f49c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-17 15:21:08 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-17 15:21:08 +0900

    merge revision(s) 0d6263bd416338a339651fb97fe4d62701704c4b: [Backport #21220]

            Fix coverage measurement for negative line numbers

            Fixes [Bug #21220]

            Co-Authored-By: Mike Bourgeous <mike@mikebourgeous.com>
            Co-Authored-By: Jean Boussier <jean.boussier@gmail.com>

commit 1c68aae91f43685766ae21485e98e76bfa331857
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-02-26 11:13:41 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-06 14:06:40 +0900

    Check LoadError first

    The message from dlerror is not our concern.

commit 54950b1f7c34db61cc922515b726a5d23426a53d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 09:09:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-06 14:06:40 +0900

    Added assertion strings with Xcode 16.3 beta

commit ffd469bd6d06df10057325a5b8c773fca009af8d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-05-06 11:29:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-05-06 11:29:37 +0900

    merge revision(s) 719486a642f0e282b02b958069b8b39b85b3aa1e: [Backport #21286]

            Fix C23 (GCC 15) WIN32 compatibility for rb_define_* functions

            Fixes [Bug #21286]

commit ccc576907a26db45f92b6898774f7159ef201205
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 14:11:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    Fixed step for cmake 3 installation

commit ab1535553b9e4806d95ed217a95188ab971ea8df
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2025-02-12 20:43:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    tool/downloader.rb: Stop caching already existing files

    Previously, the script was caching any file already present in the
    destination directory, regardless of its origin. This caused issues
    when the directory contained files copied from external sources like
    `autoreconf --install`.

    For example:
    1. `./autogen.sh --install` copies `config.guess` and `config.sub`
       from the system to `./tool`.
    2. `ruby tool/downloader.rb -d tool -e gnu config.guess config.sub`
       treats those files as if they were downloaded and caches them.
    3. Removing the files: `rm tool/config.guess tool/config.sub`.
    4. Running the downloader again, it mistakenly restores the cached
       files instead of downloading fresh versions.

commit 00343f63652e217f4d57af342a696a3337e27d5b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-01-16 18:02:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    Use configu.guess with wasi compatible version

commit 2ac9b27ba35cf5fea5abd82e5af69cfa345abdc2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 12:11:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    Bump up the latest version of actions

commit bd5f39523b109df23e7583dab6e942a9cfb982d8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:41:07 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    Bump up clang-14 with yjit-bindgen job

commit 4db3d2b885cec25d6d15f7db3638e9bc511aa0e5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:36:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    ubuntu-20.04 is retired

commit 59ae1818fc9d45107121ec54406c5874c5a75b71
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:30:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:59 +0900

    Use windows-2022 because windows-2019 is EOL at June 2025

commit b200bad6cd40d08e9f33b93e1a85c270b337867c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-09 18:23:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-09 18:23:04 +0900

    bump teeny

commit 4ca521e91342165ed35cb12c9868f10e2a6aa07c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-09 17:27:37 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-09 17:27:37 +0900

    merge revision(s) 06919949a60b42a8f30e8bd0cb075e17b05eebcd, 51bc992822f9108ad64de32d300e1cefd0e2da59, 42daa6c2a2b49b4e45f40736e25c7d182860f24a: [Backport #21141]

            [Bug #21141] [DOC] Clarify what time is in UTC

            [Bug #21141] [DOC] Refine description of `Time#utc?`

            [Bug #21141] [DOC] Fix indentation

commit a67e9e41846cdadad9bb2d9e9d10223c52253898
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-07 21:19:10 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-07 21:19:10 +0900

    merge revision(s) 3a7b9ca93b91dcc086b9ac8b9957e59268f9493b: [Backport #21217]

            Fix `Integer.sqrt` to never exceed actual value

            `Integer.sqrt` uses `sqrt(3)` from libm for small values.
            This method must return a value less than or equal to the actual integer
            square root, but libm's sqrt does not always guarantee that.

            This change corrects that by decrementing the result if necessary.

            Fixes [Bug #21217]

commit 5640fea8aada2380145375a7f9eac2b979fe1258
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-06 13:42:21 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-06 13:42:21 +0900

    Update prism test snapshots.

    This is follow-up for 7c315e23983a35d29108d9ba8c914d6320254d43.

commit 7c315e23983a35d29108d9ba8c914d6320254d43
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-06 11:24:36 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-06 11:31:57 +0900

    merge revision(s) 117d6e145a0270ab8fc9134403519ef13b9ebb24: [Backport #21027]

            [ruby/prism] Fix `not` receiver

            `not foo` should be `!foo`
            `not()` should be `!nil`

            Fixes [Bug #21027]

            https://github.com/ruby/prism/commit/871ed4b462

commit a1679f0d83845a35116d4e40bba4783346c8d7dc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:30:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 07:38:52 +0900

    Use EnvUtil.apply_timeout_scale

commit f2ee22f32d3b4919b9a5b62a81b544019383ef3a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:07:08 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-04 07:38:52 +0900

    Extend open_timeout for test failure on s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-master/log/20250403T060004Z.fail.html.gz

commit 7065e60318c970655eb561829a2071c310b67e2d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 14:18:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 19:41:48 +0900

    Use IPv4 for test server because TestNetHTTPS is failing with s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-3.2/log/20250403T005659Z.fail.html.gz

commit c48219e2d738faa388e61361c0549f7addbfacfe
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 13:04:31 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 14:10:39 +0900

    f7059af50a31 is also required at ractor_core.h

commit 31c295ef28fc678d8416f1f35726ac43d470d1d3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 09:40:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 12:54:11 +0900

    Enforce to use CMake 3 because CMake 4 is not compatible to build libyaml via vcpkg

commit 3d8a66568e8106b367665d716e0d3c8c8208aa07
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-04-02 21:16:22 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-04-02 21:16:47 +0900

    merge revision(s) d78ff6a767ca813ac5fa178dd7611f20a993c191: [Backport #20984]

            [Bug #20984] Fix test with locale encoding

commit ca0238353dd594c1012b7263b83e0c7eeb882cf4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-01 15:20:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 10:35:49 +0900

    [rubygems/rubygems] Bump up minimum required version for cmake 4

    https://github.com/rubygems/rubygems/commit/3e77caeddf

commit 51dee044c1cb079a463118c5113ae9fdf96e463e
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-30 12:11:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-30 12:11:59 +0900

    merge revision(s) 5f77f9bea61fb4cc8447a76e191fdfb28f076862: [Backport #21195]

            Fix handling of `error`/`errno` in `io_internal_wait`. (#12961)

            [Bug #21195]

commit aac5c546cd35ff0aeab120e3724fbb1296892ae3
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-29 16:49:59 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-29 16:49:59 +0900

    merge revision(s) f69ad0e810e1fdc18dc12f77bbecfa49999ef3bf: [Backport #21094]

            [Bug #21094] Update nested module names when setting temporary name

commit 770060f7662698ca74bc28428919a688b8fe06d2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-29 15:25:02 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-29 15:32:49 +0900

    merge revision(s) 1acfb29015dbc38fd345d8786aa78aad59f7dcd1: [Backport #21186]

            [Bug #21186] multibyte char literal should be a single letter word

commit d2eda78e4091a99c1a387d43967af5794d8eac70
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-29 15:21:40 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-29 15:21:40 +0900

    merge revision(s) 9459bedd84d479bb1d7d3d40bada1cecb4701c37: [Backport #19841]

            [Bug #19841] Refine error on marshaling recursive USERDEF

commit c1319d7e406ddf3f0da487296f1c4c50d90496ad
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-21 02:19:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:24:18 +0900

    [rubygems/rubygems] Support git 2.49

    One error message that we parse is now slightly different.

    https://github.com/rubygems/rubygems/commit/758528791d

commit f85e5e01bafeca387e833b9d79cab43a8b22aa3d
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 20:10:00 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 20:35:27 +0900

    merge revision(s) f423f6e10c0c226dfed98e7cb7a5d489191dfa35: [Backport #21131]

            Ensure IO.copy_stream buffer is an independent string

            Otherwise, changes to the buffer by the destination write method
            could result in data changing for supposedly independent strings.

            Fixes [Bug #21131]

commit 2b2ab1a67c236eb0c47e63e8adcf877b0d20a38c
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 18:52:56 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 18:52:56 +0900

    merge revision(s) 08b3a45bc97c835b4677bf76dbce68fd51d81897: [Backport #21180]

            Push a real iseq in rb_vm_push_frame_fname()

            Previously, vm_make_env_each() (used during proc
            creation and for the debug inspector C API) picked up the
            non-GC-allocated iseq that rb_vm_push_frame_fname() creates,
            which led to a SEGV when the GC tried to mark the non GC object.

            Put a real iseq imemo instead. Speed should be about the same since
            the old code also did a imemo allocation and a malloc allocation.

            Real iseq allows ironing out the special-casing of dummy frames in
            rb_execution_context_mark() and rb_execution_context_update(). A check
            is added to RubyVM::ISeq#eval, though, to stop attempts to run dummy
            iseqs.

            [Bug #21180]

            Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit d213eb7f453fa0bd6c476826c450d9726c3c8b15
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 18:46:04 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 18:46:29 +0900

    merge revision(s) 3f07bc76ff6a11232d9f18e5eaa31835c195e8f0, 34098b669c0cbc024cd08e686891f1dfe0a10aaf: [Backport #21144]

            [Bug #21144] Win32: Use Windows time zone ID if TZ is not set

            If the TZ environment variable is not set, the time zone names
            retrieved from the system are localized for UI display and may vary
            across editions and language packs for the same time zone.
            Use the time zone IDs that are invariant across environments instead.

            [Bug #21144] Win32: Convert the time zone name to the current locale

            The Windows time zone IDs provided by Microsoft as of 24H1 are ASCII
            only all, but the API itself is not impossible to set non-ASCII key
            name.  Prefer the current locale encoding for now until we move to
            UTF-8 including environment variables and command line arguments.

commit 726bff43b462d2a1b0bc93299cf031202f7fe7a1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 18:02:45 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 18:02:45 +0900

    merge revision(s) c224ca4feaff20cab03d76439bcbfb35d4e2f6b1: [Backport #21172]

            Fix a race condition with interned strings sweeping.

            [Bug #21172]

            This fixes a rare CI failure.

            The timeline of the race condition is:

            - A `"foo" oid=1` string is interned.
            - `"foo" oid=1` is no longer referenced and will be swept in the future.
            - Another `"foo" oid=2` string is interned.
            - `register_fstring` finds `"foo" oid=1`, but since it is about to be swept,
              removes it from `fstring_table` and insert `"foo" oid=2` instead.
            - `"foo" oid=1` is swept, since it has the `RSTRING_FSTR` flag,
              a `st_delete` is issued in `fstring_table` which removes `"foo" oid=2`.

            I don't know how to reproduce this bug consistently in a single test
            case.

commit 1d3c19871d7a0d05a0f0a80e78cfad843b7ef324
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 15:39:32 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 15:39:32 +0900

    merge revision(s) 931ac960b6d11937364b6c4e847fdd575ee67980: [Backport #21159]

            [Bug #21159] module names should not be modifiable

commit da86a9959b4c5bbdefb6fd1000a0251a151ffbc1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 15:25:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 15:25:20 +0900

    merge revision(s) 2b6fc9ea7212543a1be26768403f59c7a759b5ea: [Backport #21092]

            [Bug #21092] Fallback variables after execonf has done

            When reading from a dummy makefile, the global variables initialized
            in `init_mkmf` may not be overridden.

commit ac3f355fb33f4ce41df864f2084028610b7b38d1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-16 13:10:13 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-16 13:10:13 +0900

    Silently ignore keyword args for attr-asign method to cease segmentation fault.

commit e860cb2267cd17aef9a5e8e977d03410c213d6a2
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-08 18:21:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 18:21:16 +0900

    merge revision(s) 91a10c07579f282a94e4b5830feaeca87f9a7dd3: [Backport #21112]

            Fix a typo in WeakKeyMap argument error

            [Bug #21112]

commit fff5baf200572762a60c624bc7bea866992c2f30
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-08 18:19:14 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 18:19:14 +0900

    merge revision(s) 46b544c54955348ef1ea9692b837b061f59f91cd, d3abee739f4feb91bb9aaae33877d70c8c576db0: [Backport #21095]

            Prefer `uname -n` over `hostname`. (#12647)

            Add fallback for `hostname` if `uname` isn't available. (#12655)

commit 54dd27d89d2e6814114f1aff18836a987d5a4ab1
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-08 17:26:28 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 17:26:28 +0900

    merge revision(s) d4a1a2780c39bc648496ac92fc6e6ce2eb38ab47: [Backport #21032]

            rb_feature_p: skip `get_expanded_load_path` for absolute paths

            Ref: https://github.com/fxn/zeitwerk/pull/308

            ```ruby
            require 'benchmark'

            $LOAD_PATH << 'relative-path'

            autoload :FOO, '/tmp/foo.rb'

            puts Benchmark.realtime {
              500_000.times do
                Object.autoload?(:FOO)
              end
            }
            ```

            The above script takes 2.5 seconds on `master`, and only
            50ms on this branch.

            When we're looking for a feature with an absolute path, we don't
            need to call the expensive `get_expanded_load_path`.

commit 8274b8193e0a047d1edfff603dd2436276f906c4
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-08 17:23:15 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 17:23:15 +0900

    merge revision(s) f7059af50a31a4d27a04ace0beadb60616f3f971: [Backport #21046]

            Use no-inline version `rb_current_ec` on Arm64

            The TLS across .so issue seems related to Arm64, but not Darwin.

commit 56ba9041d9e338359b32ba0bfb3d816d57dc9d39
  Author:     nagachika <nagachika@ruby-lang.org>
  AuthorDate: 2025-03-08 17:03:20 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 17:03:20 +0900

    merge revision(s) ae6bd3b49ba252985b92416c24102ede3c0aac9b, 966458199d870b88b42898d4a063b487c1ef6b00, 966458199d870b88b42898d4a063b487c1ef6b00: [Backport #20951]

            [DOC] Tweak "Timezone Objects"

            - Make method descriptions plain pragraphs in each method.
            - Make "Argument" and "Returns" note-lists.

            [Bug #20951] [DOC] About UTC offset calculation after `utc_to_local`

            [Bug #20951] [DOC] About UTC offset calculation after `utc_to_local`

commit ef523984f0c16ec3ec1ea3b5b74ed24e6b03d561
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-06 07:21:48 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 16:43:58 +0900

    Replace tombstone when converting AR to ST hash

    [Bug #21170]

    st_table reserves -1 as a special hash value to indicate that an entry
    has been deleted. So that that's a valid value to be returned from the
    hash function, do_hash replaces -1 with 0 so that it is not mistaken for
    the sentinel.

    Previously, when upgrading an AR table to an ST table,
    rb_st_add_direct_with_hash was used which did not perform the same
    conversion, this could lead to a hash in a broken state where one if its
    entries which was supposed to exist being marked as a tombstone.

    The hash could then become further corrupted when the ST table required
    resizing as the falsely tombstoned entry would be skipped but it would
    be counted in num entries, leading to an uninitialized entry at index
    15.

    In most cases this will be really rare, unless using a very poorly
    implemented custom hash function.

    This also adds two debug assertions, one that st_add_direct_with_hash
    does not receive the reserved hash value, and a second in
    rebuild_table_with, which ensures that after we rebuild/compact a table
    it contains the expected number of elements.

    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

commit ecb9f7ef372c70c3e4fa81a5002533814a94aa86
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:14:54 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 16:27:22 +0900

    Merge cgi-0.4.2

commit e58827163002e816e49ed18007f4fa3481102b08
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:14:16 +0900
  Commit:     nagachika <nagachika@ruby-lang.org>
  CommitDate: 2025-03-08 16:27:22 +0900

    Merge uri-0.13.2

commit 188ff4d4356b1a369e2204e5c45e1d168ffdf631
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-05 18:04:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 09:09:35 +0900

    Name dependency checks job

    And run on the latest ubuntu.

commit 9472548aa1b8b82515602e543ec03872d0b139cb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-22 09:47:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 09:09:35 +0900

    automerge needs windows results

commit c462deb48262eeb4dc08255d9b859eb73759eb95
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-03-06 08:34:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 08:36:55 +0900

    Update actions/cache for ruby_3_3

commit 2e7f65acbd52e9da57e7b2c44597106ca70aebd8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-28 15:54:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-28 16:43:01 +0900

    Skip VS2022 17.13.x build

    see https://github.com/ruby/ruby/pull/12830

commit 5eb08338ca318c3ea2e367f3b00f0d1fb36270e2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:35:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:35:44 +0900

    Drop k0kubun from CODEOWNERS

    The maintainers have been shifted to newer versions.
    https://bugs.ruby-lang.org/issues/21136

commit f8b9e2c06f04ea3720d94b5268b6c62e30ad3b26
  Author:     nicholas a. evans <nick@rubinick.dev>
  AuthorDate: 2025-02-12 02:21:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-02-12 02:21:31 +0900

    Bump net-imap to 0.4.19 for Ruby 3.3 (CVE-2025-25186) (#12732)

    This update addresses CVE-2025-25186 (GHSA-7fc5-f82f-cx69).

commit 5b226fdb8df4a954476d8ee1b855539adaf82091
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-07 11:02:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-11 01:29:08 +0900

    Support `git ls-files ...`.split style for file list of gemspec

commit 84b60a03cd908c1b2efdfee65d71ffc03418ea21
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-05 14:49:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-11 01:29:08 +0900

    Bump up net-smtp-0.5.1

commit da75893dbe4e6fbde84037a4e1730a95c685cdd9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-05 14:58:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-06 09:49:44 +0900

    Bump up actions/upload-artifact-4.4.1

commit be31f993d7fa0219d85f7b3c694d454da4ecc10b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 16:22:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 16:22:35 +0900

    v3.3.7

commit b6affbca88f5e0a70bda784d5195be5f0408b5ba
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 14:25:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 14:25:34 +0900

    Skip an unstable test due to a Ractor assertion

commit e9f479d8712f7ecd3802d4438cd44161088d9713
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 14:16:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 14:16:37 +0900

    YJIT: Filter & calls from specialized C method codegen

    Evident with the crash reported in [Bug #20997], the C replacement
    codegen functions aren't authored to handle block arguments (nor
    should they because the extra code from the complexity defeats
    optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

    Co-Authored-By: Alan Wu <alanwu@ruby-lang.org>

commit 02bcfb42be7ca97fa40c6efa2f03ddff66c9257c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 14:13:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 14:13:29 +0900

    merge revision(s) 04ec07794657cd2444ecb001a522b9df2db1b90a: [Backport #21038]

            Preserve `errno` in `rb_fiber_scheduler_unblock`. (#12576)

            [Bug #21038]

            Co-authored-by: Julian Scheid <julians37@gmail.com>

commit 7b9caf19ba480d168ef4c5e93690735240975c91
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 11:00:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 11:00:02 +0900

    merge revision(s) b176d4f52e4af67654814dab3e9c5f4bf9170e54: [Backport #21008]

            [Bug #21008] Normalize before sum to float

            After switching to `Float`-mode when summing `Numeric` objects,
            normalization for `Float` is still needed.

commit 12a0807965624a0be37dc79371a69b5d787cc8d1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:59:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:59:12 +0900

    merge revision(s) 8034e9c3d001ca3dff124ab42972684eac8af2ae: [Backport #20995]

            [Bug #20995] Protect `IO.popen` block from exiting by exception

commit 0d6459249d13e247cd0eae28f59ef51b862bce80
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:58:17 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:58:17 +0900

    merge revision(s) 19c39e4cfaa467e69b9848c9c5496d7f50d39c7f: [Backport #20984]

            [Bug #20984] ENV.inspect should be encoding aware

commit 3a986b47cba80bdc081638d5f759a26c1beb8fad
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:56:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:56:25 +0900

    merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

            Avoid opt_aset_with optimization inside multiple assignment

            Previously, since the opt_aset_with optimization was introduced,
            use of the opt_aset_with optimization inside multiple assignment
            would result in a segfault or incorrect instructions.

            Fixes [Bug #21012]

            Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

commit 299455be9966c0a31dabe00014a4b8fae5093a7d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:54:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:54:19 +0900

    merge revision(s) 92dd9734a967c20e628c8f77c5ce700058dcd58c: [Backport #20950]

            Fix use-after-free in ep in Proc#dup for ifunc procs

            [Bug #20950]

            ifunc proc has the ep allocated in the cfunc_proc_t which is the data of
            the TypedData object. If an ifunc proc is duplicated, the ep points to
            the ep of the source object. If the source object is freed, then the ep
            of the duplicated object now points to a freed memory region. If we try
            to use the ep we could crash.

            For example, the following script crashes:

                p = { a: 1 }.to_proc
                100.times do
                  p = p.dup
                  GC.start
                  p.call
                rescue ArgumentError
                end

            This commit changes ifunc proc to also duplicate the ep when it is duplicated.

commit 00147cbab567b05b8a4137875bbda341ef704760
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:53:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:53:38 +0900

    merge revision(s) e90b447655dd39ad1eb645cdaae450efd605db00: [Backport #20924]

            [Bug #20924] Fix reading with delimiter in wide character encodings

commit 1b1c6e67588ef417847d36f4f4017bd18157a1d2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:52:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:52:11 +0900

    merge revision(s) f65a6c090c229de1665af49f2e51fc1d6397ab72: [Backport #20921]

            Fix use-after-free in constant cache

            [Bug #20921]

            When we create a cache entry for a constant, the following sequence of
            events could happen:

            - vm_track_constant_cache is called to insert a constant cache.
            - In vm_track_constant_cache, we first look up the ST table for the ID
              of the constant. Assume the ST table exists because another iseq also
              holds a cache entry for this ID.
            - We then insert into this ST table with the iseq_inline_constant_cache.
            - However, while inserting into this ST table, it allocates memory, which
              could trigger a GC. Assume that it does trigger a GC.
            - The GC frees the one and only other iseq that holds a cache entry for
              this ID.
            - In remove_from_constant_cache, it will appear that the ST table is now
              empty because there are no more iseq with cache entries for this ID, so
              we free the ST table.
            - We complete GC and continue our st_insert. However, this ST table has
              been freed so we now have a use-after-free.

            This issue is very hard to reproduce, because it requires that the GC runs
            at a very specific time. However, we can make it show up by applying this
            patch which runs GC right before the st_insert to mimic the st_insert
            triggering a GC:

                diff --git a/vm_insnhelper.c b/vm_insnhelper.c
                index 3cb23f06f0..a93998136a 100644
                --- a/vm_insnhelper.c
                +++ b/vm_insnhelper.c
                @@ -6338,6 +6338,10 @@ vm_track_constant_cache(ID id, void *ic)
                        rb_id_table_insert(const_cache, id, (VALUE)ics);
                    }

                +    if (id == rb_intern("MyConstant")) rb_gc();
                +
                    st_insert(ics, (st_data_t) ic, (st_data_t) Qtrue);
                }

            And if we run this script:

                Object.const_set("MyConstant", "Hello!")

                my_proc = eval("-> { MyConstant }")
                my_proc.call

                my_proc = eval("-> { MyConstant }")
                my_proc.call

            We can see that ASAN outputs a use-after-free error:

                ==36540==ERROR: AddressSanitizer: heap-use-after-free on address 0x606000049528 at pc 0x000102f3ceac bp 0x00016d607a70 sp 0x00016d607a68
                READ of size 8 at 0x606000049528 thread T0
                    #0 0x102f3cea8 in do_hash st.c:321
                    #1 0x102f3ddd0 in rb_st_insert st.c:1132
                    #2 0x103140700 in vm_track_constant_cache vm_insnhelper.c:6345
                    #3 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #4 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #5 0x1030bc1e0 in vm_exec_core insns.def:263
                    #6 0x1030b55fc in rb_vm_exec vm.c:2585
                    #7 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #8 0x102a82588 in rb_ec_exec_node eval.c:281
                    #9 0x102a81fe0 in ruby_run_node eval.c:319
                    #10 0x1027f3db4 in rb_main main.c:43
                    #11 0x1027f3bd4 in main main.c:68
                    #12 0x183900270  (<unknown module>)

                0x606000049528 is located 8 bytes inside of 56-byte region [0x606000049520,0x606000049558)
                freed by thread T0 here:
                    #0 0x104174d40 in free+0x98 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x54d40)
                    #1 0x102ada89c in rb_gc_impl_free default.c:8183
                    #2 0x102ada7dc in ruby_sized_xfree gc.c:4507
                    #3 0x102ac4d34 in ruby_xfree gc.c:4518
                    #4 0x102f3cb34 in rb_st_free_table st.c:663
                    #5 0x102bd52d8 in remove_from_constant_cache iseq.c:119
                    #6 0x102bbe2cc in iseq_clear_ic_references iseq.c:153
                    #7 0x102bbd2a0 in rb_iseq_free iseq.c:166
                    #8 0x102b32ed0 in rb_imemo_free imemo.c:564
                    #9 0x102ac4b44 in rb_gc_obj_free gc.c:1407
                    #10 0x102af4290 in gc_sweep_plane default.c:3546
                    #11 0x102af3bdc in gc_sweep_page default.c:3634
                    #12 0x102aeb140 in gc_sweep_step default.c:3906
                    #13 0x102aeadf0 in gc_sweep_rest default.c:3978
                    #14 0x102ae4714 in gc_sweep default.c:4155
                    #15 0x102af8474 in gc_start default.c:6484
                    #16 0x102afbe30 in garbage_collect default.c:6363
                    #17 0x102ad37f0 in rb_gc_impl_start default.c:6816
                    #18 0x102ad3634 in rb_gc gc.c:3624
                    #19 0x1031406ec in vm_track_constant_cache vm_insnhelper.c:6342
                    #20 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #21 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #22 0x1030bc1e0 in vm_exec_core insns.def:263
                    #23 0x1030b55fc in rb_vm_exec vm.c:2585
                    #24 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #25 0x102a82588 in rb_ec_exec_node eval.c:281
                    #26 0x102a81fe0 in ruby_run_node eval.c:319
                    #27 0x1027f3db4 in rb_main main.c:43
                    #28 0x1027f3bd4 in main main.c:68
                    #29 0x183900270  (<unknown module>)

                previously allocated by thread T0 here:
                    #0 0x104174c04 in malloc+0x94 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x54c04)
                    #1 0x102ada0ec in rb_gc_impl_malloc default.c:8198
                    #2 0x102acee44 in ruby_xmalloc gc.c:4438
                    #3 0x102f3c85c in rb_st_init_table_with_size st.c:571
                    #4 0x102f3c900 in rb_st_init_table st.c:600
                    #5 0x102f3c920 in rb_st_init_numtable st.c:608
                    #6 0x103140698 in vm_track_constant_cache vm_insnhelper.c:6337
                    #7 0x1030b91d8 in vm_ic_track_const_chain vm_insnhelper.c:6356
                    #8 0x1030b8cf8 in rb_vm_opt_getconstant_path vm_insnhelper.c:6424
                    #9 0x1030bc1e0 in vm_exec_core insns.def:263
                    #10 0x1030b55fc in rb_vm_exec vm.c:2585
                    #11 0x1030fe0ac in rb_iseq_eval_main vm.c:2851
                    #12 0x102a82588 in rb_ec_exec_node eval.c:281
                    #13 0x102a81fe0 in ruby_run_node eval.c:319
                    #14 0x1027f3db4 in rb_main main.c:43
                    #15 0x1027f3bd4 in main main.c:68
                    #16 0x183900270  (<unknown module>)

            This commit fixes this bug by adding a inserting_constant_cache_id field
            to the VM, which stores the ID that is currently being inserted and, in
            remove_from_constant_cache, we don't free the ST table for ID equal to
            this one.

            Co-Authored-By: Alan Wu <alanwu@ruby-lang.org>

commit 745fe4cf7e0c297879b46045a4838b3e5e2dfeb9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:51:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:51:27 +0900

    merge revision(s) 660b995365f719fa59ed6f2809bb1527e6470d14: [Backport #20915]

            [Bug #20915] Fix SEGV with `TracePoint#parameters` and aliased C method

            The following snippet results with a SEGV:

            ```ruby
            C = Class.new do
              alias_method :new_to_s, :to_s
            end

            TracePoint.new(:c_call, &:parameters).enable { C.new.new_to_s }
            ```

            at MRI 3.3.6 and ruby 3.4.0dev

            The root cause of the issue lies in the `rb_tracearg_parameters` function
            within the `RUBY_EVENT_C_RETURN` branch. Specifically, when the invoked
            method is an alias for a C function,
            `rb_method_entry_without_refinements(..., trace_arg->called_id, ...)`
            may return NULL. In that case we can fallback to `trace_arg->id`.

commit 1e48631e0f318a3b73cd39bdbda4619017383aac
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:50:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:50:24 +0900

    merge revision(s) 02b70256b5171d4b85ea7eeab836d3d7cfb3dbfc, 6b4f8945d600168bf530d21395da8293fbd5e8ba: [Backport #20909]

            Check negative integer underflow

            Many of Oniguruma functions need valid encoding strings

commit 8506fdfb4aca5262940b9c49827c2a839f6bb1fe
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:48:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:48:57 +0900

    merge revision(s) 3b7892b6e4d1a1a5d6019987f9b46ed443dd104f: [Backport #20871]

            Fix a bug in rb_include_module that stops nested inclusion into module subclasses

            This bug was present since the code was originally added by me
            in 3556a834a2847e52162d1d3302d4c64390df1694.

            Fixes [Bug #20871]

commit f19831a15d680fd995ceaecad1157282be7182dc
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:47:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:47:41 +0900

    merge revision(s) a8c2d5e7bee5fad0965baeb58d312ddc5932ec26: [Backport #20907]

            Ensure fiber scheduler re-acquires mutex when interrupted from sleep. (#12158)

            [Bug #20907]

commit 1ec258ab7002210670171f3f2f0c4b39657e24a4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:42:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:42:54 +0900

    merge revision(s) d71be7274bd2623bb521be72c245c08fc38d6ae4: [Backport #20873]

            [Bug #20873] Consider `-FIXNUM_MIN` overflow

            `-FIXNUM_MIN` is usually greater than `FIXNUM_MAX` on platforms using
            two's complement representation.

commit 42f043c1893b320b9d2a38ec3b1065dee71ce863
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:40:39 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:40:39 +0900

    merge revision(s) 56ecc243e230e8e99761ec0ffc5116601f094bb0: [Backport #20868]

            [Bug #20868] Fix Method#hash to not change after compaction

            The hash value of a Method must remain constant after a compaction, otherwise
            it may not work as the key in a hash table.

            For example:

                def a; end

                # Need this method here because otherwise the iseq may be on the C stack
                # which would get pinned and not move during compaction
                def get_hash
                  method(:a).hash
                end

                puts get_hash # => 2993401401091578131

                GC.verify_compaction_references(expand_heap: true, toward: :empty)

                puts get_hash # => -2162775864511574135

commit 233014639793cb6c8650a9b17d37bc09c662d430
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-01-15 10:38:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-01-15 10:38:34 +0900

    merge revision(s) 773d140f65c1c8b726e107915bc003c186f38677: [Backport #20787]

            [Bug #20787] Check the separator in `IO#readline` as well as 3.2

commit 732ee20a02bcfd92a473a7841f374ee9b8a7bbb0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-03 10:28:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-03 11:08:37 +0900

    Bump up actions/checkout-4.2.2

commit 7ff601aea00265f12a4cef1fd6c6321d6215d844
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-03 10:01:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-03 11:08:37 +0900

    Lock json-schema-5.1.0 for using pure ruby version

commit c53d12ee708662ac4b231178b08bd8a75f21ffeb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-19 16:39:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Revert "Skip tests that suddenly started failing for MinGW"

    This reverts commit f72eb702f29574b85889d3ea6447efa29c8a8789.

commit da008169578b389039845c4f1008b03da249964f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 22:49:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Win32: Expose wchar main routine only

    Warned if both of `main` and `wmain` are exposed:
    ```
    LINK : warning LNK4067: ambiguous entry point; selected 'mainCRTStartup'
    ```

commit 7e2789415b1189072b79a1144f0aa871216e6fd0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-10 21:31:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Make `MUNICODE_FLAG` simply expanded

    It is not expected that `target_os` will change going forward.

commit b4afc2b25fbe2c4112b273a5aab51f8371a4feb6
  Author:     Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  AuthorDate: 2024-11-06 21:28:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    `EXE_LDFLAGS` uses the same `MUNICODE_FLAG`

commit b7475e2ac326701776f34d4f2cfeddb7a5dca428
  Author:     Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  AuthorDate: 2024-11-06 10:01:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    `-municode` is available for MinGW-w64 targets only

commit b3a1fc146c9793c31ec59bb75f30c368dcc94aa7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-04 09:39:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Use wide character startup

    Mingw crt-git 12.0.0.r369.g0d4221712-1 now prohibits "command line
    contains characters that are not supported in the active code page".
    https://sourceforge.net/p/mingw-w64/mingw-w64/ci/0d42217123d3aec0341b79f6d959c76e09648a1e/

    Already Ruby builds `argv` in `rb_w32_sysinit`, instead of mswin- or
    mingw-made `argv`.  Just bypass the conversion in mingw crt.

commit 792826d5f4b77adf571d20b8752f5d93a1848092
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 19:56:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Make `rb_ec_set_vm_stack` conformant to the C++11 requirement

    Https://learn.microsoft.com/en-us/cpp/build/reference/zc-inline-remove-unreferenced-comdat?view=msvc-140
    > If `/Zc:inline` is specified, the compiler enforces the C++11
    > requirement that all functions declared inline must have a definition
    > available in the same translation unit if they're used.

commit d44061b91986a225dd4a9d0337853a45de9eef48
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-17 19:29:16 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Win32: Remove unreferenced COMDAT from object files

    Windows 11 SDK Version 10.0.26100.0 introduced a new internal inline
    function in ucrt/corecrt_math.h.  Even it appears in object files and
    will be included in the DEF file, it will be removed from the DLL and
    result in a linker error.

commit 5232e3ce3cdd69f9afaf5d34370f6ef3c84e4930
  Author:     MSP-Greg <Greg.mpls@gmail.com>
  AuthorDate: 2024-06-21 09:33:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    [ruby/net-http] test_https.rb - fix test_session_reuse_but_expire

    https://github.com/ruby/net-http/commit/5544243c41

commit c78721f718d1004182b36a6610d32b1a158808be
  Author:     Job Snijders <job@sobornost.net>
  AuthorDate: 2024-03-25 21:20:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    [ruby/openssl] Only CSR version 1 (encoded as 0) is allowed by PKIX standards

    RFC 2986, section 4.1 only defines version 1 for CSRs. This version
    is encoded as a 0. Starting with OpenSSL 3.3, setting the CSR version
    to anything but 1 fails.

    Do not attempt to generate a CSR with invalid version (which now fails)
    and invalidate the CSR in test_sign_and_verify_rsa_sha1 by changing its
    subject rather than using an invalid version.

    This commit fixes the following error.

    ```
     2) Error: test_version(OpenSSL::TestX509Request): OpenSSL::X509::RequestError:
    X509_REQ_set_version: passed invalid argument
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:18:in `version='
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:18:in `issue_csr'
    /home/runner/work/openssl/openssl/test/openssl/test_x509req.rb:43:in
    `test_version'
         40:     req = OpenSSL::X509::Request.new(req.to_der)
         41:     assert_equal(0, req.version)
         42:
      => 43:     req = issue_csr(1, @dn, @rsa1024, OpenSSL::Digest.new('SHA256'))
         44:     assert_equal(1, req.version)
         45:     req = OpenSSL::X509::Request.new(req.to_der)
         46:     assert_equal(1, req.version)
    ```

    https://github.com/ruby/openssl/commit/c06fdeb091

commit 068fb26c0862e10f892e89ad7b6bb31e548fde0c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-11-19 15:42:45 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-11-20 10:18:27 +0900

    Lock sinatra-4.0

commit a97621ef3c7e026651d93460bbf04d3008c5676b
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2024-11-16 07:05:28 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-11-16 07:05:28 +0900

    wasm: align fiber stack pointer to 16 bytes (#12101)

    wasm: align fiber stack pointer to 16 bytes

    In WebAssembly C ABI, the linear stack pointer must be always aligned
    to 16 bytes like other archs.
    The misaligned stack pointer causes some weird memory corruption since
    compiler assumes the aligned stack pointer.

commit a24570a62a584478a7dde5dd716b5c88fe86e9e5
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-11-13 04:20:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-11-13 04:20:36 +0900

    ObjectSpace.dump: handle Module#set_temporary_name (#12068)

    ObjectSpace.dump: handle Module#set_temporary_name

    [Bug #20892]

    Until the introduction of that method, it was impossible for a
    Module name not to be valid JSON, hence it wasn't going through
    the slower escaping function.

    This assumption no longer hold.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit f4258aaed02ee7be761f2499b0b6243a8f37b7cb
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2024-11-13 02:04:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-11-13 02:04:21 +0900

    [Bug #20886] Avoid double-free in regex timeout after stack_double (#12063)

    Fix regex timeout double-free after stack_double

    As of 10574857ce167869524b97ee862b610928f6272f, it's possible to crash
    on a double free due to `stk_alloc` AKA `msa->stack_p` being freed
    twice, once at the end of match_at and a second time in `FREE_MATCH_ARG`
    in the parent caller.

    Fixes [Bug #20886]

commit a51a6bf6926241704593b9439e91c06ee6f3ee61
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2024-11-09 18:00:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-11-09 18:00:13 +0900

    [Bug #20883] Fix coderange for sprintf on binary strings (#12040)

    Fix update_coderange for binary strings

    Although a binary (aka ASCII-8BIT) string will never have a broken
    coderange, it still has to differentiate between "valid" and "7bit".

    On Ruby 3.4/trunk this problem is masked because we now clear the
    coderange more agressively in rb_str_resize, and we happened to always
    be strinking this string, but we should not assume that.

    On Ruby 3.3 this created strings where `ascii_only?` was true in cases
    it shouldn't be as well as other problems.

    Fixes [Bug #20883]

    Co-authored-by: Daniel Colson <danieljamescolson@gmail.com>
    Co-authored-by: Matthew Draper <matthew@trebex.net>

commit 75015d4c1f6965b5e85e96fb309f1f2129f933c0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 09:49:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 09:49:11 +0900

    v3.3.6

commit f72eb702f29574b85889d3ea6447efa29c8a8789
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 09:00:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 09:00:11 +0900

    Skip tests that suddenly started failing for MinGW

    These test failures first appeared on irrelevant changes. It probably
    came from changes in GitHub Actions instead of CRuby's.

    Until we figure out how to fix these tests, let's skip them to make the
    CI usable.

commit 7237ded95f3ad624edc122b14d0276daf554a96c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:52:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:52:43 +0900

    macos-12 is deprecated and fails on Mondays

    https://github.com/actions/runner-images/issues/10721

commit 6db39f4677ff50aacfe54bd9dda052c09e1c6ab0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:43:39 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:43:39 +0900

    merge revision(s) 29c480dd6fca993590c82078ba797e2c4e876ac7: [Backport #20853]

            [Bug #20853] Fix Proc#hash to not change after compaction

            The hash value of a Proc must remain constant after a compaction, otherwise
            it may not work as the key in a hash table.

commit edeb0319f7a95dfe3f9b895bcf32371dd8514726
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:42:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:42:47 +0900

    merge revision(s) 6118e8a47394409b53164b60e79fadf348b97db3: [Backport #20716]

            Fix method caching bug when including/prepend module A that prepends module B

            Fix by always adding the generated iclass to the subclasses list,
            otherwise the method cache for the iclass is not cleared when
            the method in the module is overwritten.

            Fixes [Bug #20716]

commit 5ce0ba0d415deb99527c409cc5f1df16ce02ef3e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:39:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:39:22 +0900

    merge revision(s) 35e124832e29b65c84d4e0e4e434616859f9bdf5: [Backport #20755]

            [Bug #20755] Frozen string should not be writable via IO::Buffer

commit 12ea98e8c8af0ed6778aad26e7ec5f95e2c239e5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:38:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:38:18 +0900

    merge revision(s) 637067440f74043c6d79fc649ab8acf1afea25a5: [Backport #20752]

            [Bug #20752] Slice of readonly `IO::Buffer` also should be readonly

commit 34a0f41d0aaff190f1647a6fa0e905690d0eff98
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:37:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:37:14 +0900

    merge revision(s) c1862cbb89a6bf42dcd07d92fe4f4bfeebca5775: [Backport #20719]

            [Bug #20719] `Float` argument must be ASCII compatible

commit 2b713dcb89c620daa55d672d2933ffde333ca5de
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:36:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:36:36 +0900

    merge revision(s) d33e3d47b84a73b38644f2a3d41881ce9be6ef18: [Backport #20704]

            [Bug #20704] Win32: Fix chdir to non-ASCII path

            On Windows, `chdir` in compilers' runtime libraries uses the active
            code page, but command line arguments in ruby are always UTF-8, since
            commit:33ea2646b98adb49ae2e1781753bf22d33729ac0.

commit e7c939aea1034a463226635e11117ade42cba4e4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-11-05 07:29:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:29:25 +0900

    merge revision(s) 76ea5cde2a0f4834a5228104249b6b3346ddfc94: [Backport #20777]

            Refactor RUBY_DESCRIPTION assertions in test_rubyoptions

commit 7446f7cdd103b129b8b750f577efd29e069176c0
  Author:     Jonathan Calvert <athemeus@athemeus.com>
  AuthorDate: 2024-09-07 12:19:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-11-05 07:26:25 +0900

    merge revision(s) 0d16c36d0ab2afa2ec79b72b229e69c141ebdaba: [Backport #13831]

            [win32/registry] Fallback to UTF-8 for unknown codepages

            There are some codepages like cp708 for which no ruby encoding exists:

                $ ruby -e "Encoding.find('cp708')"
                Traceback (most recent call last):
                    1: from -e:1:in `<main>'
                -e:1:in `find': unknown encoding name - cp708 (ArgumentError)

            win32/registry uses ENCODING to transcode error messages and expand environment
            variables from UTF-16LE, so using UTF-8 seems like the best choice and is better
            than a hard failure.

            This should resolve [Bug #13831]

commit 6b3a0b4ffd12cd7f80be224efa8744534fcf2b93
  Author:     Alex Myers <myers3162002@gmail.com>
  AuthorDate: 2024-11-02 00:42:18 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-11-02 00:42:18 +0900

    Bump REXML to 3.3.9 for Ruby 3.3 (#11972)

commit c4b6ce36758fbc8d851b8b6563d0cf64cf2417db
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-10-18 11:12:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-10-22 00:41:50 +0900

    Merge syntax-suggest-2.0.1

commit 494fcc507b3bc218beb6638d33476b647d55969e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-10-17 16:12:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-10-18 00:55:01 +0900

    Merge RubyGems-3.5.22 and Bundler-2.5.22

commit d03e4228aaeb1bdd3432119e683aa259b028c5b2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-10-17 16:11:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-10-18 00:55:01 +0900

    Merge RubyGems-3.5.21 and Bundler-2.5.21

commit af7656869ee714a7124c1c655bc905e456770bd2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-09-09 17:25:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-10-01 01:16:44 +0900

    Run just bignum related tests when gmp enabled

commit 4608ef8d7b0e22d690b73dabc032e9dd43e9a446
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-30 12:03:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-10-01 01:16:44 +0900

    -l option of 7z is unknown switch with the `ubuntu-latest`.

    https://github.com/ruby/actions/actions/runs/11095032727/job/30823174026#step:3:349

commit 77fb1bf434d7be9cf5d892404b04b20c18fa6f06
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-25 16:54:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-26 02:56:17 +0900

    Merge RubyGems-3.5.20 and Bundler-2.5.20

commit 3894841182c32de231b3998502bf1a9dba7cdb4f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-25 16:54:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-26 02:56:17 +0900

    Merge RubyGems-3.5.19 and Bundler-2.5.19

commit ef3c4a7aa7c0a79a00f4daa50e0be1184d9fe536
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-25 16:53:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-26 02:56:17 +0900

    Merge RubyGems-3.5.18 and Bundler-2.5.18

commit 95f72a4a32396cae7475b39d7739fb534242b625
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-25 16:53:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-26 02:56:17 +0900

    Merge RubyGems-3.5.17 and Bundler-2.5.17

commit d8966416d010719ef8f1689137da31aa75e71198
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-09-25 02:50:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-09-25 02:50:33 +0900

    Use `PRIuSIZE` instead of `%zu` for `size_t` (#9359)

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

commit ec04de7512d512a2bcc623a72a4f17f43a01a5bf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-24 00:47:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-24 01:25:10 +0900

    Bump debug.gem to 1.9.2

commit 5b6009870dff883a8e71a05e60f175cea1d00d55
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2024-09-13 16:40:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-24 01:25:10 +0900

    Ensure fiber scheduler is woken up when close interrupts read

    If one thread is reading and another closes that socket, the close
    blocks waiting for the read to abort cleanly. This ensures that Ruby is
    totally done with the file descriptor _BEFORE_ we tell the OS to close
    and potentially re-use it.

    When the read is correctly terminated, the close should be unblocked.
    That currently works if closing is happening on a thread, but if it's
    happening on a fiber with a fiber scheduler, it does NOT work.

    This patch ensures that if the close happened in a fiber scheduled
    thread, that the scheduler is notified that the fiber is unblocked.

    [Bug #20723]

commit 4e59e7d35fbd6ff87f63cd0aa5d6a2f923323fee
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-17 09:28:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-09-17 09:28:08 +0900

    [Bug #20737] Do not warn default gems to be promoted in Ruby 3.5 (#11613)

commit 55ddfd58dd6e67e88cf9a3e55bf99550affe8b3f
  Author:     Jonathan Calvert <athemeus@athemeus.com>
  AuthorDate: 2024-09-11 09:38:48 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-09-11 09:38:48 +0900

    Fixes [Bug #20718] (#11576)

    Fixes [Bug #20718]

    Allow objects that are not of type `RTypedData` to use the default free function, as `RTYPEDDATA_EMBEDDED_P` can return a false positive when casting non-`RTypedData` objects

commit 948ca04a76c0031d17798f79fe3bbc5fb8462e90
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-06 10:00:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-06 10:00:19 +0900

    Allow failures for all Travis jobs

    Every job on Travis is unstable now.

commit c3f7041ab19fbf0e937126dc1b7397b97f768b9a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-06 09:55:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-09-06 09:55:34 +0900

    Merge reline-0.5.10 (#11558)

    * Merge reline-0.5.8

    * Merge reline-0.5.9

    * Merge reline-0.5.10

commit 4eb51dfc9e67683a1a03fdf302d5ddd95cad716a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-09-05 00:47:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-09-05 00:47:06 +0900

    Merge JSON 2.7.2 for Ruby 3.3 (#11541)

    Merge JSON 2.7.2

commit ef084cc8f4958c1b6e4ead99136631bef6d8ddba
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-03 01:09:08 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-03 01:09:08 +0900

    v3.3.5

commit d3ab7be8ca034ea58da7d6ebc77ad66e192cba18
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 19:28:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 19:28:11 +0900

    merge revision(s) 657f4b99f61: [Backport #20667]

            Update bundled gems list as of 2024-08-02

commit c69d59e9b2d3d8621e50670087d4e53b73580c75
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 19:25:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 19:25:23 +0900

    Sync tool/lib/core_assertions.rb from master

    It seems necessary to pass test-bundled-gems with REXML.

commit cf9a6c2b63e6337a3f6ce76527446739e5aceb67
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 19:19:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 19:19:13 +0900

    merge revision(s) a3562c2a0abf1c2bdd1d50377b4f929580782594: [Backport #20701]

            Remove incorrect setting of KW_SPLAT_MUT flag

            Fixes [Bug #20701]

            Co-authored-by: Pablo Herrero <pablodherrero@gmail.com>

commit d83b5633b16f4ddcece4ff924f21c5a5851470cf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 19:10:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 19:10:19 +0900

    merge revision(s) 992596fb7af18a7f472589a607d0eb3fbb03b49a: [Backport #20344]

            Fix next inside block argument stack underflow

            [Bug #20344]
            Fix compile_next adding removable adjust label

commit b210c86a0201f6a97c4da8266908260746f53ae0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 19:07:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 19:07:09 +0900

    merge revision(s) 97449338d6cb42d9dd7c9ca61550616e7e6b6ef6: [Backport #20649]

            [Bug #20649] Allow `nil` as 2nd argument of `assign_error`

            Fallback to the last token element in that case, for the backward
            compatibilities.

commit 6a4e79533b4454392f3afdfa0c4d35b763b68466
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 18:56:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 18:56:18 +0900

    merge revision(s) 1870505f478cc75993b296b7144a45137ace6937: [Backport #20651]

            Fix wrong unreachable chunk remove when jump destination label is unremovable

commit e0e23e7d5eb4da42c490b1d3408bd6e5047e8f83
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 18:52:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 18:52:51 +0900

    merge revision(s) 29500e30346: [Backport #20667]

            Update bundled gems list as of 2024-08-22

commit 7b954e7bc64e201af1dd65e264e5091310efd362
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-09-02 18:43:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-09-02 18:44:25 +0900

    Allow failures in Travis ppc64le and s390x

    Those jobs are way too unstable and provide very little benefit.

    e.g.
    https://app.travis-ci.com/github/ruby/ruby/jobs/624611955
    https://app.travis-ci.com/github/ruby/ruby/jobs/625551620

commit 937964f3467a6242bb4bf1431983e6847d529338
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-28 08:00:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-28 08:00:27 +0900

    Merge URI-0.13.1 for Ruby 3.3 (#11466)

    Merge URI-0.13.1

commit ac8d50e52ebc2d2684914e56548a64a65830c16a
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-08-24 07:48:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-24 07:48:08 +0900

    [Backport 3.3] [Bug #20691] Fix use-after-free in WeakKeyMap#clear (#11443)

    Fix use-after-free in WeakKeyMap#clear

    [Bug #20691]

    If the WeakKeyMap has been marked but sweeping hasn't started yet and we
    cann WeakKeyMap#clear, then there could be a use-after-free because we do
    not call rb_gc_remove_weak to remove the key from the GC.

    For example, the following code triggers use-after-free errors in Valgrind:

        map = ObjectSpace::WeakKeyMap.new

        1_000.times do
          1_000.times do
            map[Object.new] = nil
          end

          map.clear
        end

    Output from Valgrind:

        ==61230== Invalid read of size 8
        ==61230==    at 0x25CAF8: gc_update_weak_references (default.c:5593)
        ==61230==    by 0x25CAF8: gc_marks_finish (default.c:5641)
        ==61230==    by 0x26031C: gc_marks_continue (default.c:5987)
        ==61230==    by 0x26031C: gc_continue (default.c:2255)
        ==61230==    by 0x2605FC: newobj_cache_miss (default.c:2589)
        ==61230==    by 0x26111F: newobj_alloc (default.c:2622)
        ==61230==    by 0x26111F: rb_gc_impl_new_obj (default.c:2701)
        ==61230==    by 0x26111F: newobj_of (gc.c:890)
        ==61230==    by 0x26111F: rb_wb_protected_newobj_of (gc.c:917)
        ==61230==    by 0x2DE218: rb_class_allocate_instance (object.c:131)
        ==61230==    by 0x2E32A8: class_call_alloc_func (object.c:2141)
        ==61230==    by 0x2E32A8: rb_class_alloc (object.c:2113)
        ==61230==    by 0x2E32A8: rb_class_new_instance_pass_kw (object.c:2172)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)
        ==61230==  Address 0x2159cb00 is 0 bytes inside a block of size 8 free'd
        ==61230==    at 0x4849B2C: free (vg_replace_malloc.c:989)
        ==61230==    by 0x248EF1: rb_gc_impl_free (default.c:8512)
        ==61230==    by 0x248EF1: rb_gc_impl_free (default.c:8493)
        ==61230==    by 0x248EF1: ruby_sized_xfree.constprop.0 (gc.c:4178)
        ==61230==    by 0x4627EC: wkmap_free_table_i (weakmap.c:652)
        ==61230==    by 0x3A54AF: apply_functor (st.c:1633)
        ==61230==    by 0x3A54AF: st_general_foreach (st.c:1543)
        ==61230==    by 0x3A54AF: rb_st_foreach (st.c:1640)
        ==61230==    by 0x46203C: wkmap_clear (weakmap.c:973)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)
        ==61230==  Block was alloc'd at
        ==61230==    at 0x484680F: malloc (vg_replace_malloc.c:446)
        ==61230==    by 0x25C68E: rb_gc_impl_malloc (default.c:8527)
        ==61230==    by 0x4622E9: wkmap_aset_replace (weakmap.c:817)
        ==61230==    by 0x3A4D02: rb_st_update (st.c:1487)
        ==61230==    by 0x4623E4: wkmap_aset (weakmap.c:854)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)
        ==61230==
        ==61230== Invalid write of size 8
        ==61230==    at 0x25CB3B: gc_update_weak_references (default.c:5598)
        ==61230==    by 0x25CB3B: gc_marks_finish (default.c:5641)
        ==61230==    by 0x26031C: gc_marks_continue (default.c:5987)
        ==61230==    by 0x26031C: gc_continue (default.c:2255)
        ==61230==    by 0x2605FC: newobj_cache_miss (default.c:2589)
        ==61230==    by 0x26111F: newobj_alloc (default.c:2622)
        ==61230==    by 0x26111F: rb_gc_impl_new_obj (default.c:2701)
        ==61230==    by 0x26111F: newobj_of (gc.c:890)
        ==61230==    by 0x26111F: rb_wb_protected_newobj_of (gc.c:917)
        ==61230==    by 0x2DE218: rb_class_allocate_instance (object.c:131)
        ==61230==    by 0x2E32A8: class_call_alloc_func (object.c:2141)
        ==61230==    by 0x2E32A8: rb_class_alloc (object.c:2113)
        ==61230==    by 0x2E32A8: rb_class_new_instance_pass_kw (object.c:2172)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)
        ==61230==  Address 0x2159cb00 is 0 bytes inside a block of size 8 free'd
        ==61230==    at 0x4849B2C: free (vg_replace_malloc.c:989)
        ==61230==    by 0x248EF1: rb_gc_impl_free (default.c:8512)
        ==61230==    by 0x248EF1: rb_gc_impl_free (default.c:8493)
        ==61230==    by 0x248EF1: ruby_sized_xfree.constprop.0 (gc.c:4178)
        ==61230==    by 0x4627EC: wkmap_free_table_i (weakmap.c:652)
        ==61230==    by 0x3A54AF: apply_functor (st.c:1633)
        ==61230==    by 0x3A54AF: st_general_foreach (st.c:1543)
        ==61230==    by 0x3A54AF: rb_st_foreach (st.c:1640)
        ==61230==    by 0x46203C: wkmap_clear (weakmap.c:973)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)
        ==61230==  Block was alloc'd at
        ==61230==    at 0x484680F: malloc (vg_replace_malloc.c:446)
        ==61230==    by 0x25C68E: rb_gc_impl_malloc (default.c:8527)
        ==61230==    by 0x4622E9: wkmap_aset_replace (weakmap.c:817)
        ==61230==    by 0x3A4D02: rb_st_update (st.c:1487)
        ==61230==    by 0x4623E4: wkmap_aset (weakmap.c:854)
        ==61230==    by 0x4296BC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3788)
        ==61230==    by 0x44A9CD: vm_sendish (vm_insnhelper.c:5955)
        ==61230==    by 0x44A9CD: vm_exec_core (insns.def:898)
        ==61230==    by 0x43A0E4: rb_vm_exec (vm.c:2564)
        ==61230==    by 0x2341B4: rb_ec_exec_node (eval.c:281)
        ==61230==    by 0x236258: ruby_run_node (eval.c:319)
        ==61230==    by 0x15D665: rb_main (main.c:43)
        ==61230==    by 0x15D665: main (main.c:62)

    Co-authored-by: Jean Boussier <byroot@ruby-lang.org>

commit 8657de70aa9d16066f9761710a5a74211046dc67
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-08-23 07:54:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-23 07:54:55 +0900

    [Backport 3.3] [Bug #20688] Fix use-after-free for WeakMap and WeakKeyMap (#11439)

    * Add struct weakmap_entry for WeakMap entries

    * Refactor wmap_foreach to pass weakmap_entry

    * Use wmap_foreach for wmap_mark

    * Refactor wmap_compact to use wmap_foreach

    * Remove wmap_free_entry

    * Fix WeakMap use-after-free

    [Bug #20688]

    We cannot free the weakmap_entry before the ST_DELETE because it could
    hash the key which would read the weakmap_entry and would cause a
    use-after-free. Instead, we store the entry and free it on the next
    iteration.

    For example, the following script triggers a use-after-free in Valgrind:

        weakmap = ObjectSpace::WeakMap.new
        10_000.times { weakmap[Object.new] = Object.new }

        ==25795== Invalid read of size 8
        ==25795==    at 0x462297: wmap_cmp (weakmap.c:165)
        ==25795==    by 0x3A2B1C: find_table_bin_ind (st.c:930)
        ==25795==    by 0x3A5EAA: st_general_foreach (st.c:1599)
        ==25795==    by 0x3A5EAA: rb_st_foreach (st.c:1640)
        ==25795==    by 0x25C991: gc_mark_children (default.c:4870)
        ==25795==    by 0x25C991: gc_marks_wb_unprotected_objects_plane (default.c:5565)
        ==25795==    by 0x25C991: rgengc_rememberset_mark_plane (default.c:5557)
        ==25795==    by 0x25C991: rgengc_rememberset_mark (default.c:6233)
        ==25795==    by 0x25C991: gc_marks_start (default.c:6057)
        ==25795==    by 0x25C991: gc_marks (default.c:6077)
        ==25795==    by 0x25C991: gc_start (default.c:6723)
        ==25795==    by 0x260F96: heap_prepare (default.c:2282)
        ==25795==    by 0x260F96: heap_next_free_page (default.c:2489)
        ==25795==    by 0x260F96: newobj_cache_miss (default.c:2598)
        ==25795==    by 0x26197F: newobj_alloc (default.c:2622)
        ==25795==    by 0x26197F: rb_gc_impl_new_obj (default.c:2701)
        ==25795==    by 0x26197F: newobj_of (gc.c:890)
        ==25795==    by 0x26197F: rb_wb_protected_newobj_of (gc.c:917)
        ==25795==    by 0x2DEA88: rb_class_allocate_instance (object.c:131)
        ==25795==    by 0x2E3B18: class_call_alloc_func (object.c:2141)
        ==25795==    by 0x2E3B18: rb_class_alloc (object.c:2113)
        ==25795==    by 0x2E3B18: rb_class_new_instance_pass_kw (object.c:2172)
        ==25795==    by 0x429DDC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3786)
        ==25795==    by 0x44B08D: vm_sendish (vm_insnhelper.c:5953)
        ==25795==    by 0x44B08D: vm_exec_core (insns.def:898)
        ==25795==    by 0x43A7A4: rb_vm_exec (vm.c:2564)
        ==25795==    by 0x234914: rb_ec_exec_node (eval.c:281)
        ==25795==  Address 0x21603710 is 0 bytes inside a block of size 16 free'd
        ==25795==    at 0x4849B2C: free (vg_replace_malloc.c:989)
        ==25795==    by 0x249651: rb_gc_impl_free (default.c:8527)
        ==25795==    by 0x249651: rb_gc_impl_free (default.c:8508)
        ==25795==    by 0x249651: ruby_sized_xfree.constprop.0 (gc.c:4178)
        ==25795==    by 0x4626EC: ruby_sized_xfree_inlined (gc.h:277)
        ==25795==    by 0x4626EC: wmap_free_entry (weakmap.c:45)
        ==25795==    by 0x4626EC: wmap_mark_weak_table_i (weakmap.c:61)
        ==25795==    by 0x3A5CEF: apply_functor (st.c:1633)
        ==25795==    by 0x3A5CEF: st_general_foreach (st.c:1543)
        ==25795==    by 0x3A5CEF: rb_st_foreach (st.c:1640)
        ==25795==    by 0x25C991: gc_mark_children (default.c:4870)
        ==25795==    by 0x25C991: gc_marks_wb_unprotected_objects_plane (default.c:5565)
        ==25795==    by 0x25C991: rgengc_rememberset_mark_plane (default.c:5557)
        ==25795==    by 0x25C991: rgengc_rememberset_mark (default.c:6233)
        ==25795==    by 0x25C991: gc_marks_start (default.c:6057)
        ==25795==    by 0x25C991: gc_marks (default.c:6077)
        ==25795==    by 0x25C991: gc_start (default.c:6723)
        ==25795==    by 0x260F96: heap_prepare (default.c:2282)
        ==25795==    by 0x260F96: heap_next_free_page (default.c:2489)
        ==25795==    by 0x260F96: newobj_cache_miss (default.c:2598)
        ==25795==    by 0x26197F: newobj_alloc (default.c:2622)
        ==25795==    by 0x26197F: rb_gc_impl_new_obj (default.c:2701)
        ==25795==    by 0x26197F: newobj_of (gc.c:890)
        ==25795==    by 0x26197F: rb_wb_protected_newobj_of (gc.c:917)
        ==25795==    by 0x2DEA88: rb_class_allocate_instance (object.c:131)
        ==25795==    by 0x2E3B18: class_call_alloc_func (object.c:2141)
        ==25795==    by 0x2E3B18: rb_class_alloc (object.c:2113)
        ==25795==    by 0x2E3B18: rb_class_new_instance_pass_kw (object.c:2172)
        ==25795==    by 0x429DDC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3786)
        ==25795==    by 0x44B08D: vm_sendish (vm_insnhelper.c:5953)
        ==25795==    by 0x44B08D: vm_exec_core (insns.def:898)
        ==25795==    by 0x43A7A4: rb_vm_exec (vm.c:2564)
        ==25795==  Block was alloc'd at
        ==25795==    at 0x484680F: malloc (vg_replace_malloc.c:446)
        ==25795==    by 0x25CE9E: rb_gc_impl_malloc (default.c:8542)
        ==25795==    by 0x462A39: wmap_aset_replace (weakmap.c:423)
        ==25795==    by 0x3A5542: rb_st_update (st.c:1487)
        ==25795==    by 0x462B8E: wmap_aset (weakmap.c:452)
        ==25795==    by 0x429DDC: vm_call_cfunc_with_frame_ (vm_insnhelper.c:3786)
        ==25795==    by 0x44B08D: vm_sendish (vm_insnhelper.c:5953)
        ==25795==    by 0x44B08D: vm_exec_core (insns.def:898)
        ==25795==    by 0x43A7A4: rb_vm_exec (vm.c:2564)
        ==25795==    by 0x234914: rb_ec_exec_node (eval.c:281)
        ==25795==    by 0x2369B8: ruby_run_node (eval.c:319)
        ==25795==    by 0x15D675: rb_main (main.c:43)
        ==25795==    by 0x15D675: main (main.c:62)

    * Fix use-after-free for WeakKeyMap

    [Bug #20688]

    We cannot free the key before the ST_DELETE because it could hash the
    key which would read the key and would cause a use-after-free. Instead,
    we store the key and free it on the next iteration.

commit 9ae91eb2aa8a82315026e72fb58d89bc23432335
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-22 01:40:11 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-22 01:40:11 +0900

    Backport warning feature for bundled gems from master (#11420)

    * Make sure to always use the right `warn`

    * lib/bundled_gems.rb: more reliable caller detection

    The `2` skipped frames went out of sync and now it should be `3`.

    Rather than just update the offset, we can implement a way that
    is adaptative as long as all require decorators are also called require.

    Also we should compute the corresponding `uplevel` otherwise the
    warning will still point decorators.

    Co-authored-by: "Hiroshi SHIBATA" <hsbt@ruby-lang.org>

    * Warn ostruct for Ruby 3.5

    * Warn pstore for Ruby 3.5

    * Mark rdoc as bundled gems at Ruby 3.5

    * Warn to use win32ole without Gemfile for Ruby 3.5

    * EXACT list is mostly same as SINCE list on bundled gems.

    * Mark to warn fiddle as bundled gems for Ruby 3.5

    * Mark to warn logger as bundled gems for Ruby 3.5

    * We should use uplevel:2 in another case.

    Like the following scenario with bootsnap, that frames are same or smaller than frame_to_skip(=3).

    ---
    "/Users/hsbt/.local/share/rbenv/versions/3.3-dev/lib/ruby/3.3.0/bundled_gems.rb:69:in `block (2 levels) in replace_require'"
    "/Users/hsbt/.local/share/gem/gems/bootsnap-1.18.4/lib/bootsnap/load_path_cache/core_ext/kernel_require.rb:30:in `require'"
    "test_warn_bootsnap.rb:11:in `<main>'"
    ---

    * Delete unnecessary rubocop disable comment

    * Show correct script name with sub-feature case

    * Skip to show script name with using ruby -r option

    * Don't show script name when bundle exec and call ruby script directly.

    * Pick word fix from 34adc07372c10170b8ca36111d216cbd8e4699be

    ---------

    Co-authored-by: David Rodríguez <deivid.rodriguez@riseup.net>
    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>
    Co-authored-by: Kentaro Takeyama <75117116+obregonia1@users.noreply.github.com>

commit 66312ad913d67bfd3c2c83b174eabf537f5def84
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2024-08-15 02:19:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-15 02:19:53 +0900

    Re-initialize vm->ractor.sched.lock after fork (#11372)

    [Bug #20633] Re-initialize vm->ractor.sched.lock after fork

    Previously under certain conditions it was possible to encounter a
    deadlock in the forked child process if ractor.sched.lock was held.

    Co-authored-by: Nathan Froyd <froydnj@gmail.com>

commit 4d11a0960d1b9c88c4e85bfeffb83c5f08f7099b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-08-08 16:41:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-08-08 18:00:50 +0900

    Added bootstrap job for release workflow

commit 65cca99b30c65d462aa67969e0f16f6e45db4705
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-08-07 02:34:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-08-07 02:34:39 +0900

    parse.y: const_decl_path don't replace destination node by a literal (#11314)

    [Bug #20668]

    The `dest` node is assumed to be a `CDECL`, so overwriting it with
    a `LIT` cause a crash on the next iteration.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit f85c7deacc25738bd83ba182370c283ba82b61d4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-07-31 01:05:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-31 01:05:54 +0900

    Update RubyGems 3.5.16 and Bundler 2.5.16 for Ruby 3.3 (#11252)

    * Merge RubyGems-3.5.12 and Bundler-2.5.12

    * Merge RubyGems-3.5.13 and Bundler-2.5.13

    * Merge RubyGems-3.5.14 and Bundler-2.5.14

    * Merge RubyGems-3.5.15 and Bundler-2.5.15

    * Merge RubyGems-3.5.16 and Bundler-2.5.16

commit 0922afa95b3e390876cbea7f78d3d93d979f27d4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-07-31 01:05:09 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-31 01:05:09 +0900

    [Bug #20654] Fix floor and ceil when ndigits is large (#11277)

    * Fix floor when ndigits is large

    [Bug #20654]

    This commit fixes Integer#floor and Float#floor when the number is
    negative and ndigits is large such that 10**ndigits is a bignum.

    Previously, it would return 0 in such cases. However, this would cause
    unexpected behaviour such as:

        puts -1.floor(-5) # => -100000
        puts -1.floor(-10) # => -10000000000
        puts -1.floor(-20) # => 0

    This commit changes the last result so that it will return
    -100000000000000000000.

    * Fix ceil when ndigits is large

    [Bug #20654]

    This commit fixes Integer#ceil and Float#ceil when the number is
    negative and ndigits is large such that 10**ndigits is a bignum.

    Previously, it would return 0 in such cases. However, this would cause
    unexpected behaviour such as:

        puts 1.ceil(-5) # => 100000
        puts 1.ceil(-10) # => 10000000000
        puts 1.ceil(-20) # => 0

    This commit changes the last result so that it will return
    100000000000000000000.

commit ce565cd4b851977bf37a470bee54e441bb60486d
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-07-30 09:45:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-30 09:45:26 +0900

    [Bug #20653] Fix memory leak in String#start_with? when regexp times out (#11255)

    Fix memory leak in String#start_with? when regexp times out

    [Bug #20653]

    This commit refactors how Onigmo handles timeout. Instead of raising a
    timeout error, onig_search will return a ONIGERR_TIMEOUT which the
    caller can free memory, and then raise a timeout error.

    This fixes a memory leak in String#start_with when the regexp times out.
    For example:

        regex = Regexp.new("^#{"(a*)" * 10_000}x$", timeout: 0.000001)
        str = "a" * 1000000 + "x"

        10.times do
          100.times do
            str.start_with?(regex)
          rescue
          end

          puts `ps -o rss= -p #{$$}`
        end

    Before:

        33216
        51936
        71152
        81728
        97152
        103248
        120384
        133392
        133520
        133616

    After:

        14912
        15376
        15824
        15824
        16128
        16128
        16144
        16144
        16160
        16160

commit 6d744837abc3f7f71a1f10c7ca399201f6f05e43
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-27 12:37:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-29 11:55:48 +0900

    [Bug #20088] Fix ARCH_FLAG for cross compiling

commit 7571ad42f42939d172ec9a68dfe56aac724ee2ef
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-07-26 01:14:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-26 01:14:26 +0900

    [Bug #20650] Fix memory leak in Regexp capture group when timeout (#11244)

    Fix memory leak in Regexp capture group when timeout

    [Bug #20650]

    The capture group allocates memory that is leaked when it times out.

    For example:

        re = Regexp.new("^#{"(a*)" * 10_000}x$", timeout: 0.000001)
        str = "a" * 1000000 + "x"

        10.times do
          100.times do
            re =~ str
          rescue Regexp::TimeoutError
          end

          puts `ps -o rss= -p #{$$}`
        end

    Before:

        34688
        56416
        78288
        100368
        120784
        140704
        161904
        183568
        204320
        224800

    After:

        16288
        16288
        16880
        16896
        16912
        16928
        16944
        17184
        17184
        17200

commit 4667f8ec10269b0b5deca459f098abbdf3bae4ec
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-07-23 08:35:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-23 08:35:22 +0900

    bundled_gems.rb: Add a fast path (#11221)

    bundled_gems.rb: Add a fast path

    [Bug #20641] `Gem::BUNDLED_GEMS.warning?` adds a lot of extra
    work on top of `require`. When the call end up atually loading code
    the overhead is somewhat marginal.

    However it's not uncommon for code to go some late `require` in some
    paths, so it's expected that calling `require` with something already
    required is somewhat fast, and `bundled_gems.rb` breaks this assumption.

    To avoid this, we can have a fast path that in most case allow to
    short-circuit all the heavy computations. If we extract the feature
    basename and it doesn't match any of the bundled gems we care about
    we can return very early.

    With this change `require 'date'` is now only 1.33x slower on Ruby
    3.3.3, than it was on Ruby 3.2.2, whereas before this change it
    was at least 100x slower.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit 425e468d25a70740cef3ed676e9b82f7902e077a
  Author:     Ivo Anjo <ivo.anjo@datadoghq.com>
  AuthorDate: 2024-07-16 01:08:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-16 01:08:16 +0900

    [Backport #20633] Fix the condition for `atomic_signal_fence` (#11166)

    [Bug #20633] Fix the condition for `atomic_signal_fence`

    `AC_CHECK_DECLS` defines `HAVE_DECL_SYMBOL` to 1 if declared, 0
    otherwise, not undefined.

    Co-authored-by: kimuraw (Wataru Kimura) <kimuraw@i.nifty.jp>

commit 3427a1679a8ca30465c684ac28449f495bff8a22
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2024-07-10 00:55:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-10 00:55:04 +0900

    retry on cancelling of `getaddrinfo` (#11131)

    When the registerred unblock function is called, it should retry
    the cancelled blocking function if possible after checkints.

    For example, `SIGCHLD` can cancel this method, but it should not
    raise any exception if there is no trap handlers.

    The following is repro-code:

    ```ruby
    require 'socket'
    PN = 10_000

    1000000.times{
      p _1
      PN.times{
        fork{
          sleep rand(0.3)
        }
      }
      i = 0
      while i<PN
        cpid = Process.wait -1, Process::WNOHANG
        if cpid
          # p [i, cpid]
          i += 1
        end

        begin
          TCPServer.new(nil, 0).close
        rescue
          p $!
          exit!
        end
      end
    }
    ```

commit be1089c8ec5ba40e09b1553e36b3174bf4014d9d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 08:28:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 08:28:22 +0900

    v3.3.4

commit 17e21d815583ef7d6be03f29e90a219602497626
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 08:08:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 08:08:42 +0900

    merge revision(s) fc33559c: [Backport #20570]

            clear `kw_flag` if given hash is nil

            https://bugs.ruby-lang.org/issues/20570 is caused I missed to
            clear the `kw_flag` even if `keyword_hash` is nil.

commit df8a08fb6a1f173a9c25db15fbe390096f39c2ff
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 08:04:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 08:04:30 +0900

    merge revision(s) 75aaeb35b82da26359b9418d2963384d0c55839c: [Backport #20239]

            [Bug #20239] Fix overflow at down-casting

commit 9d583dd43a24354e8ae58c089cf091c1243e6e60
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 07:58:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 07:58:13 +0900

    merge revision(s) fba8aff7, d8c6e91748871ab2287d7703347847fe18a292d2: [Backport #20592]

            [Bug #20592] Fix segfault when sending NULL to freeaddrinfo

            On alpine freeaddrinfo does not accept NULL pointer

            Fix dangling `else`

commit 8a2e41d34b135046957e1195a5d4f4967a82a965
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 07:55:17 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 07:55:17 +0900

    merge revision(s) 2dd46bb82ffc4dff01d7ea70922f0e407acafb4e: [Backport #20468]

            [Bug #20468] Fix safe navigation in `for` variable

commit a40645e115e6cd6328bb302dfc78b16f6ad45938
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 07:42:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 07:42:06 +0900

    merge revision(s) 01b13886: [Backport #20562]

            [Bug #20562] Categorize `RUBY_FREE_AT_EXIT` warning as experimental

commit 9a8454ea5ca2bb4d6540d5c43b8e91e199ed1a8a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-07-09 07:40:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-07-09 07:40:28 +0900

    Fix malformed JSON in macOS CI

commit f811f79b3aa5d1fba3a9a631a802aa1d41fa5dc4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-07-06 00:13:11 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-06 00:13:11 +0900

    Refine macOS CI (#11107)

    Update macos runners with latest environments.

    * Use macos-14 instead of macos-arm-oss
    * Removed macos-11 and added macos-13

commit b2be36ef3349ebdab5423ea3337c03bcc3319b60
  Author:     Ivo Anjo <ivo.anjo@datadoghq.com>
  AuthorDate: 2024-07-04 01:56:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-07-04 01:56:00 +0900

    [Backport #11036] Add explicit compiler fence when pushing frames to ensure safe profiling (#11090)

    **What does this PR do?**

    This PR tweaks the `vm_push_frame` function to add an explicit compiler
    fence (`atomic_signal_fence`) to ensure profilers that use signals
    to interrupt applications (stackprof, vernier, pf2, Datadog profiler)
    can safely sample from the signal handler.

    This is a backport of #11036 to Ruby 3.3 .

    **Motivation:**

    The `vm_push_frame` was specifically tweaked in
    https://github.com/ruby/ruby/pull/3296 to initialize the a frame
    before updating the `cfp` pointer.

    But since there's nothing stopping the compiler from reordering
    the initialization of a frame (`*cfp =`) with the update of the cfp
    pointer (`ec->cfp = cfp`) we've been hesitant to rely on this on
    the Datadog profiler.

    In practice, after some experimentation + talking to folks, this
    reordering does not seem to happen.

    But since modern compilers have a way for us to exactly tell them
    not to do the reordering (`atomic_signal_fence`), this seems even
    better.

    I've actually extracted `vm_push_frame` into the "Compiler Explorer"
    website, which you can use to see the assembly output of this function
    across many compilers and architectures: https://godbolt.org/z/3oxd1446K

    On that link you can observe two things across many compilers:
    1. The compilers are not reordering the writes
    2. The barrier does not change the generated assembly output
       (== has no cost in practice)

    **Additional Notes:**

    The checks added in `configure.ac` define two new macros:
    * `HAVE_STDATOMIC_H`
    * `HAVE_DECL_ATOMIC_SIGNAL_FENCE`

    Since Ruby generates an arch-specific `config.h` header with
    these macros upon installation, this can be used by profilers
    and other libraries to test if Ruby was compiled with the fence enabled.

    **How to test the change?**

    As I mentioned above, you can check https://godbolt.org/z/3oxd1446K
    to confirm the compiled output of `vm_push_frame` does not change
    in most compilers (at least all that I've checked on that site).

commit 291cc913503475a204c93a53a2f470c8cc6bfca2
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-29 05:04:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-29 05:04:49 +0900

    [Bug #20598] Fix corruption of internal encoding string (#11069)

    Fix corruption of internal encoding string

    [Bug #20598]

    Just like [Bug #20595], Encoding#name_list and Encoding#aliases can have
    their strings corrupted when Encoding.default_internal is set to nil.

    Co-authored-by: Matthew Valentine-House <matt@eightbitraptor.com>

commit 7a780a3ef766e0622ade4a5fbf2518f73c38282b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-27 23:46:53 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-27 23:46:53 +0900

    [Bug #20595] Fix corruption of encoding name string (#11063)

    Fix corruption of encoding name string

    [Bug #20595]

    enc_set_default_encoding will free the C string if the encoding is nil,
    but the C string can be used by the encoding name string. This will cause
    the encoding name string to be corrupted.

    Consider the following code:

        Encoding.default_internal = Encoding::ASCII_8BIT
        names = Encoding.default_internal.names
        p names
        Encoding.default_internal = nil
        p names

    It outputs:

        ["ASCII-8BIT", "BINARY", "internal"]
        ["ASCII-8BIT", "BINARY", "\x00\x00\x00\x00\x00\x00\x00\x00"]

    Co-authored-by: Matthew Valentine-House <matt@eightbitraptor.com>

commit 01762837b7f98934e402c6888e15de32a673b0fd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-06-21 02:57:19 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-21 02:57:19 +0900

    [Bug #20581][3.3] Fix unintentional truncation for dependencies of bundled gems (#11006)

    * Try to load original gemspec from `.bundle/gems/foo-x.y.z/foo.gemspec`.

    `.bundle/specification/foo-x.y.z.gemspec` may be changed our toolchain

    * Try to find gemspec from `.bundle/specifications

    * Adjust indent

commit 3160434c506fe2c7c9c69965dceb6e8fd7357c28
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-21 02:41:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-21 02:41:13 +0900

    Add k0kubun to ruby_3_3 CODEOWNERS

commit d1ffd5ecfa62a049b7c508f30b6912a890de1b32
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-06-21 02:39:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-21 02:39:20 +0900

    String.new(capacity:) don't substract termlen (#11027)

    [Bug #20585]

    This was changed in 36a06efdd9f0604093dccbaf96d4e2cb17874dc8 because
    `String.new(1024)` would end up allocating `1025` bytes, but the problem
    with this change is that the caller may be trying to right size a String.

    So instead, we should just better document the behavior of `capacity:`.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit a3eb5e5c70eaee12964cdd807b8f19950003141f
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2024-06-14 02:02:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-14 02:02:32 +0900

    Don't call `Warning.warn` unless the category is enabled (#10981)

    Don't call `Warning.warn` unless the category is enabled

    The warning category should be enabled if we want to call
    `Warning.warn`.

    This commit speeds up the following benchmark:

    ```ruby
    eval "def test; " +
      1000.times.map { "'  '.chomp!" }.join(";") + "; end"

    def run_benchmark count
      i = 0
      while i < count
        start = Process.clock_gettime(Process::CLOCK_MONOTONIC)
        yield
        ms = Process.clock_gettime(Process::CLOCK_MONOTONIC) - start
        puts "itr ##{i}: #{(ms * 1000).to_i}ms"
        i += 1
      end
    end

    run_benchmark(25) do
      250.times do
        test
      end
    end
    ```

    On `master` this runs at about 92ms per iteration. With this patch, it
    is 7ms per iteration.

    [Bug #20573]

commit aa957546fa553abadd888ba18675c099df1178e0
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-06-14 02:02:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-14 02:02:02 +0900

    Bump shlex from 1.1.0 to 1.3.0 in /yjit/bindgen (#10985)

    `yjit-bindgen` isn't run to build Ruby releases at all, but people might
    be running security scanners on the source tarball. Upgrade this
    dependency to calm the scanners.

    Backport of <https://github.com/ruby/ruby/pull/9652>.
    See: <https://github.com/ruby/ruby/pull/10980>

commit f1c7b6f435f1167a0514b39a5f72f55cec4d1426
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-12 08:54:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-12 08:54:24 +0900

    v3.3.3

commit 97b1bf9ac11848c2783264d22bf7cdb7f32a21cf
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-12 08:43:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-12 08:43:32 +0900

    [Bug #20270] Fix --parser=prism (#10970)

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

commit d1869cfb852cf95b5a51025c016437ab46b12104
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-12 03:28:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-12 03:29:27 +0900

    redmine-backporter.rb: Prepend commit: to shorter revs

    Some of the places in Redmine (e.g. Associated revisions) print
    revisions using only 8 characters. Even when I copied a revision from
    there, I want to prepend commit: in the message.

commit 23f4b78ad8844ec81cb02fad25a6247a2d498582
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-12 03:17:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-12 03:17:32 +0900

    merge revision(s) 27321290: [Backport #20521]

            [Bug #20521] ripper: Clean up strterm

commit d3b139821294f56e6b31e28608c534d9f0920fc2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-12 03:11:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-12 03:11:23 +0900

    merge revision(s) 1e08a9f0e9058186db18f29efc6458c00f10a856: [Backport #20499]

            [Bug #20499] Use Xcode owned tools for Xcode clang

            Xcode has its own version tools that may be incompatible with genuine
            LLVM tools, use the tools in the same directory.

commit 8951040aadca57fce633b0f714248de78a962c22
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-06-12 03:08:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-12 03:08:31 +0900

    [3.3 backport] compile.c: use putspecialobject for RubyVM::FrozenCore (#10962)

    compile.c: use putspecialobject for RubyVM::FrozenCore

    [Bug #20569]

    `putobject RubyVM::FrozenCore`, is not serializable, we
    have to use `putspecialobject VM_SPECIAL_OBJECT_VMCORE`.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit 4c50d23245689761e04db450ced9fe9fa76997d0
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-12 03:01:29 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-12 03:01:29 +0900

    Raise SyntaxError on invalid encoding symbol (#10967)

    [Bug #20280]

    Backport of #10014.

commit 40251ed0dfe99bb09c2fa542fce603ade25e3729
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-06-11 08:05:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-11 08:05:58 +0900

    Fix inconsistent evaluation of keyword splat (#10959)

    [Bug #20180]

    Backports #9624.

commit d0327a7224d8d778a75c7554b287369895dc17be
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-06-06 06:54:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-06 06:54:24 +0900

    Don't add `+YJIT` to `RUBY_DESCRIPTION` until it's actually enabled (#10920)

    If you start Ruby with `--yjit-disable`, the `+YJIT` shouldn't be
    added until `RubyVM::YJIT.enable` is actually called. Otherwise
    it's confusing in crash reports etc.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit e0fe6f70170924397b957d6cfa84774592b1c809
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-05 16:28:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-05 16:29:17 +0900

    merge revision(s) f8abd24b1f28998157da1230b231419ef7b81722: [Backport #20522]

            Improve YJIT performance warning regression test

            [Bug #20522]

commit 06f470ce66be24f82d3720dd2bb08b18b16753ac
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-06-05 13:36:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-05 13:36:46 +0900

    Merge RubyGems 3.5.11 and Bundler 2.5.11 for Ruby 3.3 (#10870)

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 1ff55bb09dca302d42951059a73e6d237fd8c338
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-05 06:58:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-05 06:58:37 +0900

    merge revision(s) 05553cf22d43dd78b8f30cc4591230b5c000c538: [Backport #20517]

            [Bug #20517] Make a multibyte character one token at meta escape

commit 4f00d98b327e3aa23564aa765488d15bc60c9e79
  Author:     Jean byroot Boussier <jean.boussier+github@shopify.com>
  AuthorDate: 2024-06-05 05:21:58 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-05 05:21:58 +0900

    [3.3 backport] Do not emit shape transition warnings when YJIT is compiling (#10911)

    Do not emit shape transition warnings when YJIT is compiling

    [Bug #20522]

    If `Warning.warn` is redefined in Ruby, emitting a warning would invoke
    Ruby code, which can't safely be done when YJIT is compiling.

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>
    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

commit b74f669e2fbe5c63409878e7a9f9d39c8554ff77
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-06-05 05:17:41 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-06-05 05:17:41 +0900

    YJIT: Fix out of bounds access when splatting empty array (#10905)

    This is a backport of 6c8ae44a388e5c03b7db90376af3652007b574e8 with a
    test tailored to crash the 3.3.x branch (from GH-10904).

        Previously, we read the last element array even when the array was
        empty, doing an out-of-bounds access. This sometimes caused a SEGV.

        [Bug #20496]

commit 1df1538be4a494bbc5ef6e3504312a0284948709
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-05 05:14:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-05 05:14:09 +0900

    merge revision(s) f54369830f83a65fb54916d762883fbe6eeb7d0b, 338eb0065bd81ba8ae8b9402abc94804a24594cc, ac636f5709feb1d9d7a0c46a86be153be765cf21: [Backport #20516]

            Revert "Rollback to released version numbers of stringio and strscan"

            This reverts commit 6a79e53823e328281b9e9eee53cd141af28f8548.

            [ruby/strscan] StringScanner#captures: Return nil not "" for unmached capture (https://github.com/ruby/strscan/pull/72)

            fix https://github.com/ruby/strscan/issues/70
            If there is no substring matching the group (s[3]), the behavior is
            different.

            If there is no substring matching the group, the corresponding element
            (s[3]) should be nil.

            ```
            s = StringScanner.new('foobarbaz') #=> #<StringScanner 0/9 @ "fooba...">
            s.scan /(foo)(bar)(BAZ)?/  #=> "foobar"
            s[0]           #=> "foobar"
            s[1]           #=> "foo"
            s[2]           #=> "bar"
            s[3]           #=> nil
            s.captures #=> ["foo", "bar", ""]
            s.captures.compact #=> ["foo", "bar", ""]
            ```

            ```
            s = StringScanner.new('foobarbaz') #=> #<StringScanner 0/9 @ "fooba...">
            s.scan /(foo)(bar)(BAZ)?/  #=> "foobar"
            s[0]           #=> "foobar"
            s[1]           #=> "foo"
            s[2]           #=> "bar"
            s[3]           #=> nil
            s.captures #=> ["foo", "bar", nil]
            s.captures.compact #=> ["foo", "bar"]
            ```

            https://docs.ruby-lang.org/ja/latest/method/MatchData/i/captures.html
            ```
            /(foo)(bar)(BAZ)?/ =~ "foobarbaz" #=> 0
            $~.to_a        #=> ["foobar", "foo", "bar", nil]
            $~.captures #=> ["foo", "bar", nil]
            $~.captures.compact #=> ["foo", "bar"]
            ```

            * StringScanner#captures is not yet documented.
            https://docs.ruby-lang.org/ja/latest/class/StringScanner.html

            https://github.com/ruby/strscan/commit/1fbfdd3c6f

            [ruby/strscan] Bump version

            https://github.com/ruby/strscan/commit/d6f97ec102

commit 0a0338b06fcc3690346d5a3bec60bbcee85ec7ce
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-05 03:43:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-05 03:43:25 +0900

    merge revision(s) 9f708d48f6df37ee9600db9d51b57a156609a13b, 0301473fb523c71d8cdc4966971f31f502001185, 874e9fc34d728f8e2444d15aa6759befd217c464, 7f0e26b7f99bf76408569892ce20318501f74729: [Backport #20516]

            Clear runtime dependencies if default gems is specified.

            The current build system uses runtime dependencies from only
            `.bundle` directory. We shouldn't install runtime dependencies
            from rubygems.org when `make test-bundled-gems` is invoked.

            Fixed dependencies list format

            Don't need to remove ruby2_keywords dependency from drb

            Re-use strscan with ruby repo

commit 12c806acc3923115f2c6590c885e43f2f24a17e3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-05 03:31:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-05 03:32:28 +0900

    merger.rb: Put spaces in between revisions

    so that they are linked correctly on GitHub

commit c9bec74b21f0e6cf05d9b200a1636bdb8069de8c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-06-01 09:13:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-06-01 09:13:33 +0900

    merge revision(s) 70ad58cb62b195ba86a5ef07a565b22b02a040ea: [Backport #20516]

            Update bundled_gems

commit ea196a3c9f181d368ed1d308201f44a88de69b42
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-31 06:53:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-31 06:53:54 +0900

    merge revision(s) be7c91db44d6b8dba8fa11ff782965b4bfa0b3c8: [Backport #20515]

            Do not pollute toplevel namespace

commit 8f5b1bb64b6cdc09574390e7efb8cb5550762b78
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-31 05:05:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-31 05:05:32 +0900

    merge revision(s) fd549b229b0822198ddc847703194263a2186ed1: [Backport #20515]

            test_bignum: defined? returns String (#10880)
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            didn't verify the test is working properly due to mistaken auto-merge… [Bug #20515]

            bug: https://bugs.ruby-lang.org/issues/20515
            follow-up: 22e4eeda6561693367fc7a00b92b90f46b09cabd
            follow-up: https://github.com/ruby/ruby/pull/10875

commit 74ba1914dd120e0c9ea33d86eae7c5d3e5c730f1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-31 03:54:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-31 03:54:34 +0900

    merge revision(s) 22e4eeda6561693367fc7a00b92b90f46b09cabd,1ab7c412d2e3880a7ad233c32e93961888f8145c: [Backport #20515]

            ci: Test whether GMP is working in compilers.yml (#10875)

            Avoid reoccurence of [Bug #20515]

            Requires https://github.com/ruby/ruby/pull/10876 since 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b

            bug: https://bugs.ruby-lang.org/issues/20515

            RUBY_CHECK_HEADER didn't define HAVE_{header-file} (#10876)

            --with-gmp is not working at all because HAVE_GMP_H
            was missing since 18eaf0be90. [Bug #20515]

            bug: https://bugs.ruby-lang.org/issues/20515
            follow-up: https://bugs.ruby-lang.org/issues/20494
            follow-up: 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b
            follow-up: https://github.com/ruby/ruby/pull/10805

commit b13cf49036f0a454063cde25807785adc00f8995
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-31 03:13:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-31 03:13:15 +0900

    merge revision(s) 055613fd868a8c94e43893f8c58a00cdd2a81f6d,127d7a35df10ee2bc99f44b888972b2c5361d84f,e2a9b87126d59e4766479a7aa12cf7a648f46506: [Backport #20447]

            Fix pointer incompatiblity

            Since the subsecond part is discarded, WIDEVAL to VALUE conversion is
            needed.

            Some functions are not used when `THREAD_MODEL=none`

            `rb_thread_sched_destroy` is not used now at all

commit e5a195edf62fe1bf7146a191da13fa1c4fecbd71
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 09:23:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 09:23:11 +0900

    v3.3.2

commit a9b6a7bf7204cd1244da7e05fafea721cf3b2e4f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 09:11:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 09:11:36 +0900

    merge revision(s) ce20367a0e2f1fcfabebf3b6bea732fc71fa79f7: [Backport #20500]

            Define `incflags` also on mswin

commit a96233161a0e917b57c3c2cd9598d75d8b7721f5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 08:53:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 08:53:29 +0900

    merge revision(s) 5fa6ba9568e87e43e08a4daeba1572254c589fb1: [Backport #20500]

            [Bug #20500] Search non-default directories for jemalloc

            Co-Authored-by: lish82 (Hiroki Katagiri)

commit b2eb7f47b3e5f5a4681aa364ed960a0809460cdb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 08:50:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 08:50:13 +0900

    merge revision(s) 1faeb44dfcf777ace28321e80d0ebf942161a0a7,7f87ad9fc4bc45faf8cd33602a025f27c094b2fd: [Backport #20431]

            Check if macros are defined before using

            Assume macros with the same prefix would be defined together.

            Refer autoconfigured endian macro (#10572)

            Remove the case `RB_IO_BUFFER_HOST_ENDIAN` is not defined.

commit d65da20eb4ebf5fcbc7cd0333e1406e1dd3c373b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 08:48:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 08:48:51 +0900

    merge revision(s) ef3803ed4028810f9088019f0db1a366370ab53a: [Backport #20502]

            Ignore the result of pthread_kill in ubf_wakeup_thread

            After an upgrade to Ruby 3.3.0, I experienced reproducible production crashes
            of the form:

            [BUG] pthread_kill: No such process (ESRCH)

            This is the only pthread_kill call in Ruby. The result of pthread_kill was
            previously ignored in Ruby 3.2 and below. Checking the result was added in
            be1bbd5b7d40ad863ab35097765d3754726bbd54 (MaNy).

            I have not yet been able to create a minimal self-contained example,
            but it should be safe to remove the checks.

commit 0044b6aefc656874adb9266829f19870dcd3d75e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 08:34:43 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 08:35:18 +0900

    merge revision(s) bc002971b6ad483dbf69b8a275c44412bb6ab954: [Backport #20094]

            [Bug #20094] Distinguish `begin` and parentheses

commit b3f2ccea5efb060e99d289b2272ddfe413e4f051
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 08:18:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 08:18:29 +0900

    merge revision(s) 18eaf0be905e3e251423b42d6f4e56b7cae1bc3b: [Backport #20494]

            [Bug #20494] Search non-default directories for GMP

            Co-Authored-by: lish82 (Hiroki Katagiri)

commit cf643fabd5c564c1dfeb337b50b4aa76ebaa11c1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:52:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:52:15 +0900

    merge revision(s) d292a9b98ce03c76dbe13138d20b9fbf613cc02d: [Backport #20453]

            [Bug #20453] segfault in Regexp timeout

            https://bugs.ruby-lang.org/issues/20228 started freeing `stk_base` to
            avoid a memory leak. But `stk_base` is sometimes stack allocated (using
            `xalloca`), so the free only works if the regex stack has grown enough
            to hit `stack_double` (which uses `xmalloc` and `xrealloc`).

            To reproduce the problem on master and 3.3.1:

            ```ruby
            Regexp.timeout = 0.001
            /^(a*)x$/ =~ "a" * 1000000 + "x"'
            ```

            Some details about this potential fix:

            `stk_base == stk_alloc` on
            [init](https://github.com/ruby/ruby/blob/dde99215f2bc60c22a00fc941ff7f714f011e920/regexec.c#L1153),
            so if `stk_base != stk_alloc` we can be sure we called
            [`stack_double`](https://github.com/ruby/ruby/blob/dde99215f2bc60c22a00fc941ff7f714f011e920/regexec.c#L1210)
            and it's safe to free. It's also safe to free if we've
            [saved](https://github.com/ruby/ruby/blob/dde99215f2bc60c22a00fc941ff7f714f011e920/regexec.c#L1187-L1189)
            the stack to `msa->stack_p`, since we do the `stk_base != stk_alloc`
            check before saving.

            This matches the check we do inside
            [`stack_double`](https://github.com/ruby/ruby/blob/dde99215f2bc60c22a00fc941ff7f714f011e920/regexec.c#L1221)

commit 5c06e930748ef6bdb4ac4751ba16b7b604da3db0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:47:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:47:26 +0900

    merge revision(s) 6ade36c06b7cef948099b8f5f483763498705d12: [Backport #20414]

            `Fiber#raise` recursively raises on nested resuming_fiber. (#10482)

            * Improve consistency of `Fiber.current.raise`.

commit b44c02ad5a1c5c8c1c62b83eec96cf3a8a2107bc
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:44:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:44:55 +0900

    merge revision(s) c479492a6701dcef3d3a96de8946ecf7beb079d4: [Backport #20427]

            Resize ary when `Array#sort!` block modifies embedded ary

            In cases where `rb_ary_sort_bang` is called with a block and
            tmp is an embedded array, we need to account for the block
            potentially impacting the capacity of ary.

            ex:
            ```
            var_0 = (1..70).to_a
            var_0.sort! do |var_0_block_129, var_1_block_129|
              var_0.pop
              var_1_block_129 <=> var_0_block_129
            end.shift(3)
            ```

            The above example can put the array into a corrupted state
            resulting in a heap buffer overflow and possible segfault:
            ```
            ERROR: AddressSanitizer: heap-buffer-overflow on address [...]
            WRITE of size 560 at 0x60b0000034f0 thread T0 [...]
            ```

            This commit adds a conditional to determine when the capacity
            of ary has been modified by the provided block. If this is
            the case, ensure that the capacity of ary is adjusted to
            handle at minimum the len of tmp.

commit 5688bcb54a640b353bed4ff49032ea00f947e1aa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:43:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:43:01 +0900

    merge revision(s) 5d1702e01a36e11b183fe29ce10780a9b1a41cf0: [Backport #20413]

            Enumerator should use a non-blocking fiber, change `rb_fiber_new` to be non-blocking by default. (#10481)

commit a24f19742bfa398a3b32c51df01133db7bcbc6e0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:40:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:40:49 +0900

    merge revision(s) 58918788abd63901588e4aa1e39b5c057321c10a: [Backport #20342]

            [Bug #20342] Consider wrapped load in `main` methods

commit 72a45ac7a3cc9bbecf641ac505f8ee791c9da48c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 07:11:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 07:11:56 +0900

    merge revision(s) 3a04ea2d0379dd8c6623c2d5563e6b4e23986fae: [Backport #20305]

            [Bug #20305] Fix matching against an incomplete character

            When matching against an incomplete character, some `enclen` calls are
            expected not to exceed the limit, and some are expected to return the
            required length and then the results are checked if it exceeds.

commit 6e46a363a8f29d93cf6992805ee67d029cea030f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 03:46:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:46:33 +0900

    merge revision(s) a7ff264477105b5dc0ade6facad4176a1b73df0b: [Backport #20393]

            Don't clear pending interrupts in the parent process. (#10365)

commit 541fc816fcb697307d666fed644ddd07ca5e942e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 03:35:46 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:35:46 +0900

    [ruby/zlib] Bump up 3.1.1

commit 2ae6df6d03c6d9750be559641c4c9f3b39eac62d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 03:35:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:35:23 +0900

    merge revision(s) 9f8f32bf9f3758ba67dd2afe7e07d9eccb68bbc7: [Backport #20289]

            [ruby/zlib] In Zlib::GzipReader#eof? check if we're actually at eof

            Only consider it eof if we read ahead and something fills the buf.
            If not, we may only have empty blocks and the footer.

            Fixes https://github.com/ruby/zlib/pull/56

            https://github.com/ruby/zlib/commit/437bea8003

commit 2f4fe76eff0a8c6ab7a1d2fb845453acfc3cb206
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-02-23 07:34:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:13:02 +0900

    Skip under_gc_compact_stress on s390x (#10073)

commit 548c7cb9f517dcb8029bd9698187c81819e08edd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 03:07:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:07:07 +0900

    merge revision(s) 7e4b1f8e1935a10df3c41ee60ca0987d73281126: [Backport #20322]

            [Bug #20322] Fix rb_enc_interned_str_cstr null encoding

            The documentation for `rb_enc_interned_str_cstr` notes that `enc` can be
            a null pointer, but this currently causes a segmentation fault when
            trying to autoload the encoding. This commit fixes the issue by checking
            for NULL before calling `rb_enc_autoload`.

commit 8f1084db9b07cb74f99de70d6f8bb6076d27d8aa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 03:00:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 03:00:27 +0900

    merge revision(s) dc146babf47a84bbd1f176d766637d4a40327019,f23d5028059078a346efc977287b669d494a5a3f,a0f7de814ae5c299d6ce99bed5fb308a05d50ba0: [Backport #20296]

            [Bug #20296] Clear errinfo when `exception: false`

            [Bug #20296] Refine the test

            [Bug #20296] Fix the default assertion message

commit 22c1e5f126db8e057bdb48d91aa5ae449e019226
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 02:57:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:57:43 +0900

    Suppress -Wclobbered warnings

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit e5a1119f1b4fd93d60540cd4277e61851c3ebe45
  Author:     Hiroya Fujinami <make.just.on@gmail.com>
  AuthorDate: 2023-12-30 01:08:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:51:23 +0900

    Reduce `if` for decreasing counter on OP_REPEAT_INC (#9393)

    This commit also reduces the warning `'stkp' may be used
    uninitialized in this function`.

commit bcf5cd3ba47e70c5c1c6328f61887bbac2f9d41b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-01-24 19:33:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:48:19 +0900

    Initialize errno variables and fix maybe-uninitialized warnings

commit bbb3075c46b838da3bac5e699837cf0cc90320d9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 02:33:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:39:10 +0900

    Sort backport revisions by commit timestamps

commit f12c947192aa47b355015384e5c82cbf674023f1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 02:19:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:19:49 +0900

    merge revision(s) e04146129ec6898dd6a9739dad2983c6e9b68056: [Backport #20292]

            [Bug #20292] Truncate embedded string to new capacity

commit a8b2317d16fa172edd3cd7e6fcb3bc694287d109
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 02:02:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 02:02:15 +0900

    merge revision(s) 78d9fe69479d32214a52ad7291c3973f1b6b7f6f: [Backport #20286]

            Ensure that exiting thread invokes end-of-life behaviour. (#10039)

commit 6aaf673e4d3fa1f8a90e6006aadefddcb87fe1de
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 01:59:52 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 01:59:52 +0900

    Skip broken SSL provider tests for freebsd

commit 6e9dbcbacc489a4cf992c2cd9987c8031fa19fb3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 01:56:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 01:56:55 +0900

    Force-skip a LOAD_PATH spec for rhel_zlinux

commit 3cab9b997945ba5d3d06b374d5e12e07293f8e73
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2023-12-30 12:14:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 01:40:45 +0900

    Change test_warmup_frees_pages to check each size pool

    This should help in debugging the intermittent test failures on CI:

        TestProcess#test_warmup_frees_pages [test/ruby/test_process.rb:2779]:
        <201> expected but was
        <202>.

commit 8c29a3776e9e9ba070425c5b6548ecbc8ee21366
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 01:38:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 01:38:46 +0900

    Skip a flaky Ractor test

    https://github.com/ruby/ruby/actions/runs/9289798294/job/25564563437

commit 015d6bae8b5bfe44708c824419c8a72e5b7b4837
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-30 01:32:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-30 01:32:03 +0900

    Skip a flaky test in RBS

commit 9cb804a2bd6eb43b67a716ccef6db400e47f29cf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 09:46:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 09:46:47 +0900

    merge revision(s) 04729fe68dceddab045be7324e26c2bb15aa62c7: [Backport #20288]

            Fix exception handling in `rb_fiber_scheduler_set`. (#10042)

commit 0e96dd93c51337a01fa29b563c2d330c472b03b7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 09:45:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 09:46:44 +0900

    merger.rb: Don't ask "conflicts resolved?" if not needed

commit 4d34fb54b0e21af3802cddb669f34fe446ed5f3d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 09:17:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 09:17:04 +0900

    redmine-backporter.rb: Prepend commit: to every revision

commit 6383d0afac6aa02b3e72d08128cc1d8327f149fa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 09:10:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 09:10:33 +0900

    merge revision(s) 015b0e2e1d312e2be60551587389c8da5c585e6f,ac1e9e443a0d6a4d4c0801c26d1d8bd33d9eb431: [Backport #20195]

            YJIT: Fix unused warnings

            ```
            warning: unused import: `condition::Condition`
              --> src/asm/arm64/arg/mod.rs:13:9
               |
            13 | pub use condition::Condition;
               |         ^^^^^^^^^^^^^^^^^^^^
               |
               = note: `#[warn(unused_imports)]` on by default

            warning: unused import: `rb_yjit_fix_mul_fix as rb_fix_mul_fix`
               --> src/cruby.rs:188:9
                |
            188 | pub use rb_yjit_fix_mul_fix as rb_fix_mul_fix;
                |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

            warning: unused import: `rb_insn_len as raw_insn_len`
               --> src/cruby.rs:142:9
                |
            142 | pub use rb_insn_len as raw_insn_len;
                |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^
                |
                = note: `#[warn(unused_imports)]` on by default
            ```

            Make asm public so it stops warning about unused public stuff in there.

            YJIT: Fix ruby2_keywords splat+rest and drop bogus checks

            YJIT didn't guard for ruby2_keywords hash in case of splat calls that
            land in methods with a rest parameter, creating incorrect results.

            The compile-time checks didn't correspond to any actual effects of
            ruby2_keywords, so it was masking this bug and YJIT was needlessly
            refusing to compile some code. About 16% of fallback reasons in
            `lobsters` was due to the ISeq check.

            We already handle the tagging part with
            exit_if_supplying_kw_and_has_no_kw() and should now have a dynamic guard
            for all splat cases.

            Note for backporting: You also need 7f51959ff1.

            [Bug #20195]

commit d7ad60373988487ae746129dfd7f65df1dd13b86
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 09:00:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 09:01:13 +0900

    redmine-backporter.rb: Remove an unneeded space

    from #backport_command_string

    I don't want to leave unneeded spaces in the command history by
    copy-pasting the entire line.

commit 9c81bbbbb738a5747eab5455292536369977ee92
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 08:55:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 08:55:49 +0900

    merge revision(s) 7f51959ff14fbe06bc1afd283d1af17b26161cf4: [Backport #20204]

            YJIT: Move guard up for a case of splat+rest

            Previously, YJIT put the guard for having enough items to extract from
            splat array at a place where the side exit is invalid, so if the guard
            fails, YJIT could raise something other than ArgumentError. Move the
            guard up to a place before any stack manipulation.

            [Bug #20204]

commit 912c7df0a51455b764fc3008a99365f79213e8e0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 08:52:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 08:52:29 +0900

    Skip a failing spec for rhel_zlinux

    https://rubyci.s3.amazonaws.com/rhel_zlinux/ruby-3.3/log/20240528T214850Z.fail.html.gz

    ```
    1)
    Execution variable $: default $LOAD_PATH entries until sitelibdir included have @gem_prelude_index set FAILED
    Expected ["/home/chkbuild/build/20240528T214850Z/mspec/lib/mspec/lib",
     "/home/chkbuild/build/20240528T214850Z/mspec/lib",
     "./ruby/tool/lib",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/site_ruby/3.3.0",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/site_ruby/3.3.0/s390x-linux",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/site_ruby",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/vendor_ruby/3.3.0",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/vendor_ruby/3.3.0/s390x-linux",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/vendor_ruby",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/3.3.0",
     "/home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/3.3.0/s390x-linux"].include? "/home/chkbuild/build/20240528T214850Z/lib/ruby/site_ruby/3.3.0"
    to be truthy but was false
    /home/chkbuild/build/20240528T214850Z/rubyspec/language/predefined_spec.rb:885:in `block (2 levels) in <top (required)>'
    /home/chkbuild/build/20240528T214850Z/rubyspec/language/predefined_spec.rb:846:in `<top (required)>'
    ```

    It does have /home/linux1/chkbuild/tmp/build/20240528T214850Z/lib/ruby/site_ruby/3.3.0,
    so it seems actually fine. It seems to be failing due to its setup
    issues. Skipping this until we figure out how to fix it.

commit 9443606caf22b5b9f3285a6ab5ea86e3ac210e23
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-05-18 15:34:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 08:38:55 +0900

    [rubygems/rubygems] Should rescue vendored net-http exception

    https://github.com/rubygems/rubygems/commit/7d2c4cf364

commit 239a8cc7d7c6cc60e5f32865ebfcd5e2f5c9c08d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 08:28:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 08:30:45 +0900

    merger.rb: Auto-detect tickets when --ticket is not given

commit 90fda2da5f0d5841b80d7f8dca4b38aaf2a80f51
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 07:42:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 07:54:54 +0900

    merger.rb: Drop an obsoleted command from help

    It was needed only for SVN, and we dropped SVN support.

commit 077558ee2b8dd3ed414b78384f21118f833eb259
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-05-29 07:54:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-05-29 07:54:39 +0900

    [Bug #20511] Update reline-0.5.7 (#10848)

    * Update reline-0.5.7

    * Update irb-1.13.1

commit 917f3e5d22b3364002eb1fdc2f94b35ff76f6a73
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 07:15:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 07:17:51 +0900

    merge revision(s) f36a71e26995b69ff72bc132bbcf40ad89571414: [Backport #20307]

            [Bug #20307] Fix `Hash#update` to make frozen copy of string keys

commit 7d3e71330fd38c402ae4a6ec14f43eb95cf50435
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-27 01:22:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 07:17:51 +0900

    Extract `RHASH_STRING_KEY_P`

commit 691aab8d3af36343c01f6d02cb6d3c0aea4a1f4f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-26 23:47:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 07:17:51 +0900

    Extract `RHASH_IDENTHASH_P`

commit 4024feba55ccf7525e4e1e0fdbca9eda5dac3b86
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-01-30 06:37:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 07:05:52 +0900

    Fix RegExp warning causing flaky Ripper failure

    Sometimes this file get picked up and break Ripper tests:

        TestRipper::Generic#test_parse_files:test/ruby
        assert_separately failed with error message
        pid 63392 exit 0
        | test_regexp.rb:2025: warning: character class has duplicated range

    https://github.com/ruby/ruby/actions/runs/7699956651/job/20982702553#step:12:103

commit 93d7bf5c5c635567fa519affdfd54edeb9064834
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-05-29 06:52:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-05-29 06:52:47 +0900

    merge revision(s) bbd249e351af7e4929b518a5de73a832b5617273: [Backport #20192] (#10249)

    * merge revision(s) bbd249e351af7e4929b518a5de73a832b5617273: [Backport #20192]

            YJIT: Properly reject keyword splat with `yield`

            We don't have support for keyword splat anywhere, but we tried to
            compile these anyways in case of `invokeblock`. This led to bad things
            happening such as passing the wrong value and passing a hash into
            rb_yjit_array_len(), which raised in the middle of compilation.

            [Bug #20192]

    * Skip a new test for RJIT

commit f18ba2c6c6a9b2a74a8c2d655ab42947edb1fc6a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 06:28:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 06:29:07 +0900

    merger.rb: Use commit: prefix in more places

commit b77b5c191513f5f281e72a51e6b2de29e2d2d7a6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 06:21:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 06:22:45 +0900

    merge revision(s) 5e0c17145131e073814c7e5b15227d0b4e73cabe: [Backport #20169]

            Make io_fwrite safe for compaction

            [Bug #20169]

            Embedded strings are not safe for system calls without the GVL because
            compaction can cause pages to be locked causing the operation to fail
            with EFAULT. This commit changes io_fwrite to use rb_str_tmp_frozen_no_embed_acquire,
            which guarantees that the return string is not embedded.

commit 62f450285bbe1f8fbbaf12540d6538985234f3d8
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 06:05:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 06:10:26 +0900

    merger.rb: Improve the help message

    It wasn't clear whether the backport command takes a commit hash or a
    ticket number.

commit 4c007195663796ca0650f2cadddbd38284996b8a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 05:58:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:58:23 +0900

    Allow failing test-annocheck

    It causes flaky failures like this:

    ```
    + /usr/bin/docker build --rm -t ruby-fedora-annocheck-copy --build-arg=FILES=ruby -f ../src/tool/annocheck/Dockerfile-copy .
    DEPRECATED: The legacy builder is deprecated and will be removed in a future release.
                Install the buildx component to build images with BuildKit:
                https://docs.docker.com/go/buildx/

    Sending build context to Docker daemon  556.5MB

    Step 1/6 : FROM docker.io/fedora:latest
    toomanyrequests: You have reached your pull rate limit. You may increase the limit by authenticating and upgrading: https://www.docker.com/increase-rate-limit
    ```

    It seems not that important to maintain the job for backports, so let's
    allow failing it until we fix it in master branch.

commit c564c4a0992d15c4b1a2c395061c9a95bc060767
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 05:53:43 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:53:43 +0900

    Sync merger.rb from master

commit 82ff749451aa54bc282cffc916736fd62fa65f4d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 05:39:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:39:30 +0900

    Sync redmine-backporter.rb from master

commit 46dbcd8e9b9c2b20be0af58ada427ff4a5f1794b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-05-29 05:39:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:39:05 +0900

    Sync .gitignore from master

    to avoid committing unrelated files unexpectedly

commit 8dda932bcded3607c189d169333bbad0860d7efd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-26 11:10:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Fix extension installer for out-of-place build

    https://github.com/ruby/ruby/pull/9673#issuecomment-2019028293

commit cf460840b825f2fd7521b0ae211353080d33ceef
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 15:16:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Guard makefile target at cross-build

    http://rubyci.s3.amazonaws.com/crossruby/crossruby-master-aarch64/log/20240325T041917Z.fail.html.gz

commit 716473e348eb74c5d437f570cd0d2a1efe30a8ae
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 17:12:31 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Use load_gemspec instead of Gem::Specification.load.

    We need to purge `git ls-files` from gemspec in default gems.

commit 1849046d1f51b3630d5c68e2e6ff0746860eac9d
  Author:     David Rodriguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-03-21 01:18:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Consider extensions in gems outside of ext/

commit e60ad0b6f5ba9ad2da83472049cd7dd6f830139e
  Author:     David Rodriguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-03-21 01:17:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Extract `root` helper

    It holds the root directory for each type of default gem (ext/ or lib/).

commit 642cf3fc8a0f7c31875d4bbc3628f835ebfc48a5
  Author:     David Rodriguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-03-19 04:58:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Consider `target_prefix` in extension Makefiles

commit 57b56225acbf2d0c08c3c9271c531e389359f453
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-01-24 18:22:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Consistently put requirable features in default gemspecs file list

commit 7ff330419f6beba9828681421762d6b495656056
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-01-24 18:16:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Fix gemspec file list for extension gems

    So that it also includes requirable features provided by extensions.

commit a63114323b614429998e7f9d30d9b344d271f20a
  Author:     David Rodriguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-03-21 01:10:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Simplify FileCollector interface

commit e43393ac0f0376bb831f310de285a4e72837c972
  Author:     David Rodriguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-03-21 00:43:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:30:26 +0900

    Use `$ext_build_dir` consistently

    Instead of hardcoded "ext".

commit 6edd65a080b156f1ce78fdcf57214c1644a049db
  Author:     Eugene Kenny <elkenny@gmail.com>
  AuthorDate: 2024-04-24 20:10:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    [Bug #20450] Remove rubyarchdir from bootsnap paths

commit 718a78cdf552fe08e4f90a29b062542ceeecfe60
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-08 16:20:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Added test case for bundled gems warning with -r option.

    This is for 76914d474d93b7485973c3bca4fa43b59f5bd383

commit a121e698401b947655921a071ee2edf01992219d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 13:31:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Bootsnap and Zeitwerk are working correctly now

commit edebbade1b48613f59c7cc7fcc82ece601b54dce
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 13:22:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Add newline each test script

commit 178de0e95356e6be288b1b722fd3a02d1db10bd8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 12:45:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Added test script for bundled_gems.rb with zeitwerk

commit 7a3cc549465125d48bedd0a22660a379914340a8
  Author:     Masataka Pocke Kuwabara <kuwabara@pocke.me>
  AuthorDate: 2024-04-08 12:41:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Fix error when default gem is loaded from `-r` option

    This patch fixes an error when a default gem that will be migrated to
    a bundled gem is loaded from `-r` option.

    Problem
    ===

    `bundle exec ruby -rostruct -e ''` unexpectedly raises the following error:

    ```console
    $ ruby -v
    ruby 3.4.0dev (2024-04-08T02:39:00Z master 6f7e8e278f) [arm64-darwin21]
    $ bundle init && bundle install
    $ bundle exec ruby -rostruct -e ''
    /Users/kuwabara.masataka/.rbenv/versions/trunk/lib/ruby/3.4.0+0/bundled_gems.rb:111:in 'Gem::BUNDLED_GEMS.warning?': undefined method 'find' for nil (NoMethodError)

          caller = caller_locations(3, 3).find {|c| c&.absolute_path}
                                         ^^^^^
            from /Users/kuwabara.masataka/.rbenv/versions/trunk/lib/ruby/3.4.0+0/bundled_gems.rb:75:in 'block (2 levels) in Kernel#replace_require'
    ```

    Solution
    ===

    This patch uses a safe navigation operator to fix this problem. By this
    change, the command will show the warning message correctly.

    ```console
    $ bundle exec ruby -rostruct -e ''
    warning: ostruct was loaded from the standard library, but will no longer be part of the default gems since Ruby 3.5.0. Add ostruct to your Gemfile or gemspec.
    ```

commit 121cec845a0c3d3529ebfdebafb339dddbfdeb90
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-01-19 16:08:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    Ignore warnings on the bundled gems repo

commit 0b3a2cf5d33688378a0d947f1623879838fb9c4c
  Author:     Jean Boussier <byroot@ruby-lang.org>
  AuthorDate: 2024-03-25 16:45:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-05-29 05:29:22 +0900

    lib/bundled_gems.rb: dynamically ignore Kernel.require decorators

    Followup: https://github.com/ruby/ruby/pull/10347

    This avoid directly referencing bootsnap and zeitwerk, and also
    handle other gems that may decorate `require`.

commit b6c07acedb3ca56471754a082b3db20bb863c92e
  Author:     KJ Tsanaktsidis <ktsanaktsidis@zendesk.com>
  AuthorDate: 2024-05-29 05:17:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-05-29 05:17:24 +0900

    Backport bug #20493 to Ruby 3.3 (#10798)

    Inline RB_VM_SAVE_MACHINE_CONTEXT into BLOCKING_REGION

    There's an exhaustive explanation of this in the linked redmine bug, but
    the short version is as follows:

    blocking_region_begin can spill callee-saved registers to the stack for
    its own use. That means they're not saved to ec->machine by the call to
    setjmp, since by that point they're already on the stack and new,
    different values are in the real registers. ec->machine's end-of-stack
    pointer is also bumped to accomodate this, BUT, after
    blocking_region_begin returns, that points past the end of the stack!

    As far as C is concerned, that's fine; the callee-saved registers are
    restored when blocking_region_begin returns. But, if another thread
    triggers GC, it is relying on finding references to Ruby objects by
    walking the stack region pointed to by ec->machine.

    If the C code in exec; subsequently does things that use that stack
    memory, then the value will be overwritten and the GC might prematurely
    collect something it shouldn't.

    [Bug #20493]

commit 1c991f3bf40c2e506a819732dd0c4afe5d3c5f46
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2024-03-12 22:39:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-30 14:02:50 +0900

    [ruby/openssl] test_asn1.rb: Remove the assertions of the time string format without second.

    This commit fixes the following errors in the tests.
    Because the OpenSSL project changed the code to make the time string format
    without second invalid. So, we drop the assertions.

    ```
    1) Error: test_generalizedtime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: generalizedtime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:433:in `test_generalizedtime'
         430:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(9999, 9, 8, 23, 43, 39))
         431:     # LibreSSL 3.6.0 requires the seconds element
         432:     return if libressl?
      => 433:     decode_test B(%w{ 18 0D }) + "201612081934Z".b,
         434:       OpenSSL::ASN1::GeneralizedTime.new(Time.utc(2016, 12, 8, 19, 34, 0))
         435:     # not implemented
         436:     # decode_test B(%w{ 18 13 }) + "https://github.com/ruby/openssl/commit/201612081934+0930".b,

    2) Error: test_utctime(OpenSSL::TestASN1): OpenSSL::ASN1::ASN1Error: utctime is too short
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:698:in `decode_test'
    /home/runner/work/ruby-openssl/ruby-openssl/test/openssl/test_asn1.rb:411:in `test_utctime'
         408:     end
         409:     # Seconds is omitted. LibreSSL 3.6.0 requires it
         410:     return if libressl?
      => 411:     decode_test B(%w{ 17 0B }) + "1609082343Z".b,
         412:       OpenSSL::ASN1::UTCTime.new(Time.utc(2016, 9, 8, 23, 43, 0))
         413:     # not implemented
         414:     # decode_test B(%w{ 17 11 }) + "https://github.com/ruby/openssl/commit/500908234339+0930".b,
    ```

    https://github.com/ruby/openssl/commit/2e826d5715

commit 85863f4d4d6f798a3a2afc33be243e5604c222a6
  Author:     Xi Ruoyao <xry111@xry111.site>
  AuthorDate: 2024-04-24 14:42:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-04-30 14:02:50 +0900

    [ruby/net-http] Skip test_session_reuse_but_expire with OpenSSL 3.3

    OpenSSL 3.3.0 9 Apr 2024 is also broken.

    Signed-off-by: Xi Ruoyao <xry111@xry111.site>

    https://github.com/ruby/net-http/commit/ab525c956d

commit c56cd86388092faec079981f779f140717020d58
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2024-04-23 19:20:14 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-04-23 19:20:14 +0900

    v3.3.1

commit dde99215f2bc60c22a00fc941ff7f714f011e920
  Author:     Isaac Peka <7493006+isaac-peka@users.noreply.github.com>
  AuthorDate: 2023-08-24 20:14:33 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-04-22 16:42:03 +0900

    Fix handling of reg->dmin in Regex matching

commit c38fc1bb36597264840d96d7475b9891c61c5240
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-12 14:01:47 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-04-22 16:29:28 +0900

    Fix Use-After-Free issue for Regexp

    Co-authored-by: Isaac Peka <7493006+isaac-peka@users.noreply.github.com>

commit 7227b859a7bf7626ee73de8130796657b7c7f3b5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-04-16 11:22:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-04-16 11:22:22 +0900

    Merge RubyGems 3.5.9 and Bundler 2.5.9 (Fixed CI at Ruby 3.3) (#10348)

    * Merge RubyGems-3.5.6 and Bundler-2.5.6

    * Merge RubyGems-3.5.7 and Bundler-2.5.7

    * Merge RubyGems-3.5.8 and Bundler-2.5.8

    * Partly reverted about https://github.com/rubygems/rubygems/pull/7483

    * Merge RubyGems-3.5.9 and Bundler-2.5.9

commit 2f654588d9e0cefff1c23529d2f2672029e1bd21
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-25 17:09:56 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-25 17:09:56 +0900

    Backport https://github.com/ruby/ruby/pull/10347 (#10349)

    Fix incorrect warning target with Zeitwerk and support warning with Bootsnap.

commit 6d6818883b8f613fe9b6c72ac7eb9b313bba097b
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-22 10:33:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-22 10:33:40 +0900

    merge revision(s) b176315827d1082f43628013a7d89fda02724d33: [Backport #20324] (#10329)

    [Bug #20324] Uncomparable ranges are not overlapping

commit a24802e8fd7e05077256605885c82ffd8221bc94
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-22 09:25:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-22 09:25:36 +0900

    merge revision(s) c7ce2f537f96ab2cf2f5fc2982d6147866ff5340: [Backport #20304] (#10311)

    Fix memory leak in setting encodings

            There is a memory leak in Encoding.default_external= and
            Encoding.default_internal= because the duplicated name is not freed
            when overwriting.

                10.times do
                  1_000_000.times do
                    Encoding.default_internal = nil
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                 25664
                 41504
                 57360
                 73232
                 89168
                105056
                120944
                136816
                152720
                168576

            After:

                9648
                9648
                9648
                9680
                9680
                9680
                9680
                9680
                9680
                9680

commit eb7cb164cffc86b63d2e2528c73e160c33b7a2e5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-03-21 16:12:38 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 16:12:38 +0900

    CVE-2024-27281 for Ruby 3.3 (#10316)

    Merge RDoc-6.6.3.1

commit f79b1d1ef1f7aa64d20f0eadbb3b0f8f7084deb3
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 14:31:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 14:31:36 +0900

    merge revision(s) e626da82eae3d437b84d4f9ead0164d436b08e1a,f3af5ae7e6c1c096bbfe46d69de825a02b1696cf: [Backport #20311] (#10312)

    Don't pin named structs defined in Ruby

            [Bug #20311]

            `rb_define_class_under` assumes it's called from C and that the
            reference might be held in a C global variable, so it adds the
            class to the VM root.

            In the case of `Struct.new('Name')` it's wasteful and make
            the struct immortal.

            Make Struct memory leak test faster

            [Bug #20311]

            It times out on some platform, so we can reduce iterations.
            On my machine it completes in 250ms and RSS grows 8X.

commit 57a0afe2090b8d05673d650b1e8bf9ae67449b1f
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 11:23:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 11:23:21 +0900

    merge revision(s) 081ee3d35509110f383cb7dd8d1205def0cdd1e8,1c97abaabae6844c861705fd07f532292dcffa74: [Backport #19907] (#10315)

    Add memory leak test for eval kwargs

            De-dup identical callinfo objects

            Previously every call to vm_ci_new (when the CI was not packable) would
            result in a different callinfo being returned this meant that every
            kwarg callsite had its own CI.

            When calling, different CIs result in different CCs. These CIs and CCs
            both end up persisted on the T_CLASS inside cc_tbl. So in an eval loop
            this resulted in a memory leak of both types of object. This also likely
            resulted in extra memory used, and extra time searching, in non-eval
            cases.

            For simplicity in this commit I always allocate a CI object inside
            rb_vm_ci_lookup, but ideally we would lazily allocate it only when
            needed. I hope to do that as a follow up in the future.

commit 821719a505bbc628ddd80b90ae892666006eada1
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 11:18:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 11:18:06 +0900

    merge revision(s) d3279a0c11ca45ca85027e7eb74dc4aac52c478b: [Backport #20327] (#10313)

    [Bug #20327] Do not count subsecond to calculate UTC offset

            Assume that there will never be any time zones with UTC offsets that
            are subseconds.  Historically, UTC offset has only been used down to
            the second.

commit a63e979853783601a60228b45741f8b3776e5507
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 10:45:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 10:45:01 +0900

    merge revision(s) d19d683a354530a27b4cbb049223f8dc70c75849,de1a586ecc2ee7f465f0c0a69291054136a3a819: [Backport #20250] (#10308)

    rb_obj_setup: do not copy RUBY_FL_SEEN_OBJ_ID

            [Bug #20250]

            We're seting up a new instance, so it never had an associated
            object_id.

            proc.c: get rid of `CLONESETUP`
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            [Bug #20253]

            All the way down to Ruby 1.9, `Proc`, `Method`, `UnboundMethod`
            and `Binding` always had their own specific clone and dup routine.

            This caused various discrepancies with how other objects behave
            on `dup` and `clone. [Bug #20250], [Bug #20253].

            This commit get rid of `CLONESETUP` and use the the same codepath
            as all other types, so ensure consistency.

            NB: It's still not accepting the `freeze` keyword argument on `clone`.

            Co-Authored-By: Étienne Barrié <etienne.barrie@gmail.com>

commit a406c516685f1950269c4e43d13cc748f0bfbc06
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 10:28:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 10:28:51 +0900

    merge revision(s) ae8990aef098410ecc2b5f48fea9d7d171a3c5f6: [Backport #20183] (#10310)

    Alias init functions

            The extension library has each initialization function named "Init_" +
            basename. If multiple extensions have the same base name (such as
            cgi/escape and erb/escape), the same function will be registered for
            both names.

            To fix this conflict, rename the initialization functions under sub
            directories using using parent names, when statically linking.

commit 05787897f69087abdabee926971cdf364bd73730
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 09:10:44 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 09:10:44 +0900

    merge revision(s) 18ee7c9a108bf3424814565377c8796e5e455cf7,4a6384ed9358e8fb8464f6e37efb5477182f01db: [Backport #20246] (#10309)

    Clear all refined CCs on reopening refinement mod

            In cfd7729ce7a31c8b6ec5dd0e99c67b2932de4732 we started using inline
            caches for refinements. However, we weren't clearing inline caches when
            defined on a reopened refinement module.

            Fixes [Bug #20246]

            Fix [Bug #20246]: Don't set next_head_exact if a capture is called (#9897)

commit b2c2702f20abfd4bb5f38cad60170e2bbb3adff9
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 09:05:07 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 09:05:07 +0900

    merge revision(s) 01fd262e62076277a41af72ea13f20deb1b462a2: [Backport #20245] (#10307)

    Fix crash when checking symbol encoding

            [Bug #20245]

            We sometimes pass in a fake string to sym_check_asciionly. This can crash
            if sym_check_asciionly raises because it creates a CFP with the fake
            string as the receiver which will crash if GC tries to mark the CFP.

            For example, the following script crashes:

                GC.stress = true
                Object.const_defined?("\xC3")

commit 00cb72157a60c20a9b9d9fe81fc974ea83d672b4
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-21 02:13:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-21 02:13:59 +0900

    merge revision(s) 3e6e3ca2627b1aa71b17de902cc1b8188246a828: [Backport #20207] (#10299)

    Correctly handle consecutive lookarounds (#9738)

            Fix [Bug #20207]
            Fix [Bug #20212]

            Handling consecutive lookarounds in init_cache_opcodes is buggy, so it
            causes invalid memory access reported in [Bug #20207] and [Bug #20212].
            This fixes it by using recursive functions to detected lookarounds
            nesting correctly.

commit c626c201e4129bbea17583ecef73472c6f668c81
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 22:40:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 22:40:50 +0900

    merge revision(s) 01bfd1a2bf013a9ed92a9722ac5228187e05e6a8,1c120efe02d079b0a1dea573cf0fd7978d9cc857,31378dc0969f4466b2122d730b7298dd7004acdf: [Backport #20228] (#10301)

    Fix memory leak in OnigRegion when match raises

            [Bug #20228]

            rb_reg_onig_match can raise a Regexp::TimeoutError, which would cause
            the OnigRegion to leak.

            Fix memory leak in stk_base when Regexp timeout

            [Bug #20228]

            If rb_reg_check_timeout raises a Regexp::TimeoutError, then the stk_base
            will leak.

            Add memory leak test for Regexp timeout

            [Bug #20228]

commit ce372be903e5f3597f1dc83cb558f165850b3bee
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 22:40:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 22:40:46 +0900

    merge revision(s) ade56737e2273847426214035c0ff2340b43799a: [Backport #20190] (#10300)

    Fix coderange of invalid_encoding_string.<<(ord)

            Appending valid encoding character can change coderange from invalid to valid.
            Example: "\x95".force_encoding('sjis')<<0x5C will be a valid string "\x{955C}"

commit 69cee6fee50f63cd52d59325dc3780a6fc4e5ae2
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 20:05:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 20:05:31 +0900

    merge revision(s) 771a2f039b9a059a73e8f111d1d46590fa697f63: [Backport #20213] (#10297)

    Fix incorrect use of VM_CALL_KW_SPLAT_MUT in zsuper with keyword splat

            For zsuper calls with a keyword splat but no actual keywords, the
            keyword splat is passed directly, so it cannot be mutable, because
            if the callee accepts a keyword splat, changes to the keyword splat
            by the callee would be reflected in the caller.

            While here, simplify the logic when the method supports
            literal keywords.  I don't think it is possible for
            a method with has_kw param flags to not have keywords, so add an
            assertion for that, and set VM_CALL_KW_SPLAT_MUT in a single place.

commit 0793cbbfde261f4fc9bf7045594d62a21e391811
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 20:05:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 20:05:21 +0900

    merge revision(s) ef276858d9295208add48e27208c69184dc50472: [Backport #20197] (#10296)

    Trigger postponed jobs on running_ec if that is available

            Currently, any postponed job triggered from a non-ruby thread gets sent
            to the main thread, but if the main thread is sleeping it won't be
            checking ints. Instead, we should try and interrupt running_ec if that's
            possible, and only fall back to the main thread if it's not.

            [Bug #20197]
            ---
             ractor.c | 16 ++++++++++++++++
             1 file changed, 16 insertions(+)

commit 23bfe6218a690bbde5143e26bc6fb243347fb4b3
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 20:05:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 20:05:08 +0900

    merge revision(s) b14674b236445fb70f484603e678722760f678f4: [Backport #20194] (#10295)

    Memory leak with TracePoint on bmethod

            [Bug #20194]

            When disabling the TracePoint on bmethod, the hooks list is not freed.

            For example:

                obj = Object.new
                obj.define_singleton_method(:foo) {}
                bmethod = obj.method(:foo)
                tp = TracePoint.new(:return) {}

                10.times do
                  100_000.times do
                    tp.enable(target: bmethod) {}
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                18208
                22832
                26528
                29728
                34000
                37776
                40864
                44400
                47680
                51504

            After:

                16688
                17168
                17168
                17248
                17696
                17760
                17824
                17824
                17856
                17920
            ---
             test/ruby/test_settracefunc.rb | 13 +++++++++++++
             vm_trace.c                     |  1 +
             2 files changed, 14 insertions(+)

commit 7ae8abc23961bf4fa143a7a2cc0bc38167d468ae
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-20 20:00:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-20 20:00:47 +0900

    merge revision(s) bb59696614083660241ef272f222628cbfa95844: [Backport #20098] (#10298)

    Fix [Bug #20098]: set counter value for {n,m} repetition correctly (#9391)

commit bd42c1725a3bba0f97831aa3dbaa6924f506a5f3
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2024-03-15 01:27:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-15 01:27:35 +0900

     Backport #20096 to Ruby 3.3 (#9471)

    Fix memory overread in registry.rb

    The terminator is not actually getting filled in; we're simply passing
    (two) bytes of empty memory as the NUL terminator. This can lead to
    garbage characters getting written to registry values.

    Fix this by explicitly putting a WCHAR_NUL character into the string to
    be sent to the registry API, like we do in the MULTI_SZ case.

    [Bug #20096]

commit 606dd03e9b0d4cf65ef56e52fab063e3ed5ef797
  Author:     KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au>
  AuthorDate: 2024-03-15 01:27:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-15 01:27:05 +0900

    [Bug #20208] Revert "Set AI_ADDRCONFIG when making getaddrinfo(3) calls for outgoi… (#9791)

    Revert "Set AI_ADDRCONFIG when making getaddrinfo(3) calls for outgoing conns"

    This reverts commit 673ed41c81cf5a6951bcb2c3dec82d7bd6ea7440.

commit 53f0c5a4e8834f11af0f903d2c59754d9be2a7f2
  Author:     Kerem Kat <keremkat@gmail.com>
  AuthorDate: 2024-03-15 01:26:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-15 01:26:35 +0900

    Backport #9498 to Ruby 3.3 (#9805)

    Handle mmap failures for redblack tree cache

    The redblack tree cache is totally optional, so if we can't allocate
    room for the cache, then just pretend as if the cache is full if mmap
    fails

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit cdcabd8a44ee2f4a2b549a3460a5c77c2dffca36
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-03-15 01:26:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-15 01:26:02 +0900

    Backport 3.3: YJIT memory leak fix with additional CI fixes (#9841)

    merge revision(s) 2cc7a56e,b0711b1,db5d9429: [Backport #20209]

            YJIT: Avoid leaks by skipping objects with a singleton class

            For receiver with a singleton class, there are multiple vectors YJIT can
            end up retaining the object. There is a path in jit_guard_known_klass()
            that bakes the receiver into the code, and the object could also be kept
            alive indirectly through a path starting at the CME object baked into
            the code.

            To avoid these leaks, avoid compiling calls on objects with a singleton
            class.

            See: https://github.com/Shopify/ruby/issues/552

            [Bug #20209]
            ---
             yjit/bindgen/src/main.rs       |  1 +
             yjit/src/codegen.rs            | 17 +++++++++++++++++
             yjit/src/cruby_bindings.inc.rs |  1 +
             yjit/src/stats.rs              |  2 ++
             4 files changed, 21 insertions(+)

            YJIT: Fix tailcall and JIT entry eating up FINISH frames (#9729)

            Suppose YJIT runs a rb_vm_opt_send_without_block()
            fallback and the control frame stack looks like:

            ```
            will_tailcall_bar [FINISH]
            caller_that_used_fallback
            ```

            will_tailcall_bar() runs in the interpreter and sets up a tailcall.
            Right before JIT_EXEC() in the `send` instruction, the stack will look like:

            ```
            bar [FINISH]
            caller_that_used_fallback
            ```

            Previously, JIT_EXEC() ran bar() in JIT code, which caused the `FINISH`
            flag to return to the interpreter instead of to the JIT code running
            caller_that_used_fallback(), causing code to run twice and probably
            crash. Recent flaky failures on CI about "each stub expects a particular
            iseq" are probably due to leaving methods twice in
            `test_optimizations.rb`.

            Only run JIT code from the interpreter if a new frame is pushed.
            ---
             test/ruby/test_optimization.rb | 11 +++++++++++
             vm_exec.h                      |  3 ++-
             2 files changed, 13 insertions(+), 1 deletion(-)

            YJIT: No need to RESTORE_REG now that we reject tailcalls

            Thanks to Kokubun for noticing.

            Follow-up: b0711b1cf152afad0a480ee2f9bedd142a0d24ac
            ---
             vm_exec.h | 1 -
             1 file changed, 1 deletion(-)

commit fafe5db7328eb3395ac4559992701b5f25ab49f4
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-14 23:18:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-14 23:18:15 +0900

    merge revision(s) b3d612804946e841e47d14e09b6839224a79c1a4: [Backport #20150] (#10253)

    Fix memory leak in grapheme clusters

            [Bug #20150]

            String#grapheme_cluters and String#each_grapheme_cluster leaks memory
            because if the string is not UTF-8, then the created regex will not
            be freed.

            For example:

                str = "hello world".encode(Encoding::UTF_32LE)

                10.times do
                  1_000.times do
                    str.grapheme_clusters
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                26000
                42256
                59008
                75792
                92528
                109232
                125936
                142672
                159392
                176160

            After:

                9264
                9504
                9808
                10000
                10128
                10224
                10352
                10544
                10704
                10896
            ---
             string.c                 | 98 +++++++++++++++++++++++++++++++-----------------
             test/ruby/test_string.rb | 11 ++++++
             2 files changed, 75 insertions(+), 34 deletions(-)

commit 2a84aaf4a8c8d6d6bbb09416711922532b0033fe
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-14 18:55:52 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-14 18:55:52 +0900

    Fix test session reuse but expire (#9824) (#10250)

    merge revision(s) 596db9c1f486d6609a4e97d82c8c71b54609fb6f: [Backport #20090]

            [Feature #19370] Blocks without anonymous parameters should not
             affect

            ---
             parse.y                  | 4 ++--
             test/ruby/test_syntax.rb | 7 +++++++
             2 files changed, 9 insertions(+), 2 deletions(-)

commit a889304fed63c3206f27d614ab75219271fb4ca9
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-14 18:42:28 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-14 18:42:28 +0900

    merge revision(s) 6c0e58a54e3fda604386d9c409e2a9998bbc9352: [Backport #20198] (#10252)

    Make sure the correct error is raised for EAI_SYSTEM resolver fail

            In case of EAI_SYSTEM, getaddrinfo is supposed to set more detail in
            errno; however, because we call getaddrinfo on a thread now, and errno
            is threadlocal, that information is being lost. Instead, we just raise
            whatever errno happens to be on the calling thread (which can be
            something very confusing, like `ECHILD`).

            Fix it by explicitly propagating errno back to the calling thread
            through the getaddrinfo_arg structure.

            [Bug #20198]
            ---
             ext/socket/raddrinfo.c | 25 +++++++++++++++++++------
             1 file changed, 19 insertions(+), 6 deletions(-)

commit 72d04bb073e6897fb4228d5b0b31ad02cbb91036
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2023-12-26 15:05:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-03-14 18:38:42 +0900

    Disable to run appveyor anymore

      [Feature #19982]

commit 8c4b5ac53b42b5bbbb279d17128b64ae685e7274
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-12-25 22:12:19 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-03-14 18:38:42 +0900

    Skip AppVeyor and GitHub if only other CI files are changed

commit 577f9c7a8334bb33512f01e7db95f6fb15e280b2
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-03-14 16:53:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-03-14 16:53:14 +0900

    Backport 37ed86fd3c798e298fad9db6e7df1f3f45e1e03b (#10248)

    merge revision(s) 37ed86fd3c798e298fad9db6e7df1f3f45e1e03b: [Backport #--ticket=20161]

            Fix memory leak in regexp grapheme clusters

            [Bug #20161]

            The cc->mbuf gets overwritten, so we need to free it to not leak memory.

            For example:

                str = "hello world".encode(Encoding::UTF_32LE)

                10.times do
                  1_000.times do
                    str.grapheme_clusters
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                15536
                15760
                15920
                16144
                16304
                16480
                16640
                16784
                17008
                17280

            After:

                15584
                15584
                15760
                15824
                15888
                15888
                15888
                15888
                16048
                16112
            ---
             regparse.c | 3 ++-
             1 file changed, 2 insertions(+), 1 deletion(-)

commit ade02f3c8909a8bf630af2c88f00b7bd7ff02682
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2024-03-04 11:57:04 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-03-04 11:57:04 +0900

    merge revision(s) 051a874325c177e040301878069c2b28f5d06ce6: [Backport #20096]

            Fix memory overread in registry.rb

            The terminator is not actually getting filled in; we're simply passing
            (two) bytes of empty memory as the NUL terminator. This can lead to
            garbage characters getting written to registry values.

            Fix this by explicitly putting a WCHAR_NUL character into the string to
            be sent to the registry API, like we do in the MULTI_SZ case.

            [Bug #20096]
            ---
             ext/win32/lib/win32/registry.rb | 7 ++-----
             1 file changed, 2 insertions(+), 5 deletions(-)

commit 3f0e3ede02f7d4b31c9073c9eb912f11aa4349cd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-02-05 23:51:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-05 23:51:16 +0900

    YJIT: Fix exits on splatkw instruction (#9715)

    [[Bug #20214]](https://bugs.ruby-lang.org/issues/20214)

commit ac526abcd6d82545b8dc3586efb55d75f45f7417
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-02-05 23:51:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-05 23:51:04 +0900

    Merge RubyGems 3.5.5 and Bundler 2.5.5 (#9676)

    * Merge RubyGems-3.5.4 and Bundler-2.5.4

    * Merge RubyGems-3.5.5 and Bundler-2.5.5

    * Make tests play with upstream Ruby tests

    CI broke in https://github.com/ruby/ruby/pull/9604 because if any Ruby
    tests run `require 'net/http'`, they will pollute the
    `$LOADED_FEATURES` for the RubyGems tests. We can fix this by renaming
    the test default gem from `net-http` to `my-http`.

    See https://github.com/rubygems/rubygems/pull/7379#issuecomment-1901241299
    for more details.

    ---------

    Co-authored-by: Stan Hu <stanhu@gmail.com>

commit 7f97e3540ce448b501bcbee15afac5f94bb22dd9
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2024-02-05 23:50:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-05 23:50:20 +0900

    [Backport 3.3] [Bug #20085] Use consistent default options for `-mbranch-protection` (#9385)

    [Bug #20085] Use consistent default options for `-mbranch-protection`

    We need to use the same options for both C compiler and assembler
    when `-mbranch-protection` is guessed by configure. Otherwise,
    `coroutine/arm64/Context.{h,S}` will use incompatible PAC strategies.

commit 288d84d827da6cb8a56ed614a9839a06488986c0
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-02-05 17:41:56 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-05 17:41:56 +0900

    merge revision(s) 2554c5d3b8738a248cedb2fea96dfab9fbe19417: [Backport #20231] (#9831)

    Don't wait in `io_binwrite_string` if not necessary. (#9792)

            ---
             io.c | 8 +++-----
             1 file changed, 3 insertions(+), 5 deletions(-)

commit d7dc57a545d75c01313a9020b162ebb648a3ea18
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-02-04 22:54:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-04 22:54:36 +0900

    merge revision(s) c5cf4d4e129f64cb69aaf0a829aed068ef1943c4: [Backport#19542] (#9829)

    merge revision(s) c5cf4d4e129f64cb69aaf0a829aed068ef1943c4: [Backport #19542]

            Improve behavioural consistency of unallocated (zero length)
             `IO::Buffer`. (#9532)

            This makes the behaviour of IO::Buffer.new(0) and IO::Buffer.new.slice(0, 0) consistent.

            Fixes https://bugs.ruby-lang.org/issues/19542 and https://bugs.ruby-lang.org/issues/18805.
            ---
             io_buffer.c                 | 14 ++++++--------
             test/ruby/test_io_buffer.rb | 35 +++++++++++++++++++++++++++++++++++
             2 files changed, 41 insertions(+), 8 deletions(-)

commit a065b68bd8d93505304f90bbb1855c864e17ad61
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-02-04 14:37:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-04 14:37:33 +0900

    Backport #9415 to ruby_3_3 (#9424)

    YJIT: Let RubyVM::YJIT.enable respect --yjit-stats

commit ba16b340981942eda82d6328800b8098c452c0ca
  Author:     Maxime Chevalier-Boisvert <maxime.chevalierboisvert@shopify.com>
  AuthorDate: 2024-02-04 14:36:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-04 14:36:34 +0900

    YJIT: reduce default exec mem size to 48MiB (#9692)

    * YJIT: reduce default exec mem size to 48MiB based

    Based on user feedback from @jhawthorn and others.
    Better for small and memory-constrained deployments.

    NOTE: This commit should be included in the next Ruby 3.3.x point
    release. @xrxr should we tag someone specific?

    * YJIT: Update yjit.md about mem size (#9687)

    ---------

    Co-authored-by: Takashi Kokubun <takashikkbn@gmail.com>

commit ce6863a0cf971e0c0328e3fc85b10b6de36ecbad
  Author:     NARUSE, Yui <nurse@users.noreply.github.com>
  AuthorDate: 2024-02-04 13:13:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-02-04 13:13:15 +0900

    merge revision(s) 18573b8d054f655e3e8b24902985bf4028f88810: [Backport #20178] (#9822)

    Avoid reading unused lvars in Primitive.cexpr

            Previously on builds with optimizations disabled, this could result in
            an out of bounds read. When we had all of:
            * built with -O0
            * Leaf builtin
            * Primitive.mandatory_only
            * "no args builtin", called by vm_call_single_noarg_inline_builti
            * The stack is escaped to the heap via binding or a proc

            This is because mk_builtin_loader generated reads for all locals
            regardless of whether they were used and in the case we generated a
            mandatory_only iseq that would include more variables than were actually
            available.

            On optimized builds, the invalid accesses would be optimized away, and
            this also was often unnoticed as the invalid access would just hit
            another part of the stack unless it had been escaped to the heap.

            The fix here is imperfect, as this could have false positives, but since
            Primitive.cexpr! is only available within the cruby codebase itself
            that's probably fine as a proper fix would be much more challenging (the
            only false positives we found were in rjit.rb).

            Fixes [Bug #20178]

            Co-authored-by: Adam Hess <HParker@github.com>
